<?php
namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Input;
use Illuminate\Support\Facades\Response;

class AlertController extends BaseController {

    public function getAlerts(Request $request){

        $filter = $request->input("filter");

        $alarmList = DB::table('Alert')->join('CustomerDevice', 'CustomerDevice.id', '=', 'Alert.id_deviceplc')
            ->select('CustomerDevice.idDispositivo', 'CustomerDevice.ip', 'CustomerDevice.port',
                'Alert.tag', 'Alert.register', 'Alert.value', 'Alert.date')
            ->whereBetween('Alert.date', [$filter['initDate'] . ' 00:00:00', $filter['endDate'] . ' 23:59:59'])
            ->where ( "CustomerDevice.id_customer", "=", $filter['id_customer'] );

        if($filter['id_device'] > 0){
            $alarmList = $alarmList->where ( "CustomerDevice.id", "=", $filter['id_device'] );
        }

        $alarmList = $alarmList->get();

        return Response::json ( array (
            'success' => true,
            'alarmList' => $alarmList
        ) );
    }

    public function getCustomers(){

        $customers = DB::table('Customer')
            ->select('id', 'name', 'company')
            ->where ( "status", "=", 1 )
            ->get ();

        return Response::json ( array (
            'success' => true,
            'customers' => $customers
        ) );
    }

    public function getDevices(Request $request){

        $id_customer = $request->input("id_customer");

        $devices = DB::table('CustomerDevice')
            ->select('id', 'ip', 'port', 'idDispositivo')
            ->where ( "id_customer", "=", $id_customer )
            ->where ( "status", "=", 1 )
            ->get();

        return Response::json ( array (
            'success' => true,
            'devices' => $devices
        ) );
    }


}
