<?php
namespace App\Http\Controllers;

use App\Console\Utils;
use App\Models\DeviceFileVars;
use App\Models\File;
use App\Models\PathGraphic;
use App\Models\Settings;
use App\Models\User;
use GuzzleHttp\Client;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Response;
use Illuminate\Support\Facades\DB;
use Illuminate\Routing\Controller as BaseController;

use App\Models\Registro;
use App\Models\CustomerDevice;
use Illuminate\Support\Facades\Input;
use Excel;
use App\Models\Customer;
use App\Models\LoginRecord;
use App\Models\Event;
use App\Models\Router;

class DevicesController extends BaseController {

	public function getDevices(Request $request) {

			$user = $request->input("user");

			$devices = CustomerDevice::with('customer', 'router', 'paths')->where('type', '=', 1);

			if($user['type'] == 2 || $user['type'] == 3){
				$devices = $devices->where('id_customer', '=', $user['id']);
			}

			$devices = $devices->get();
			if(count($devices) > 0){
				$devices = $devices->toArray ();

				foreach($devices as &$device){

					$lastRecord = DB::table('Registro')->where('id_device', '=', $device['id'])->orderBy('datetime', 'desc')->first();

					if(is_object($lastRecord))
						$device['last_record'] = $lastRecord;

				}
			}


		return Response::json ( array (
			'success' => true,
		    'devices' => $devices
		) );
	}

	public function getDevice(Request $request) {

	    $id_device = $request->input("id_device");
	    $serchCriteria = $request->input("serchCriteria");

	    $previousHour = $serchCriteria['date'] . ' ' . $serchCriteria['hour'] . ':00';
	    $initMinute = 0;
		$lastMinute = 60;
		$labels = array();

	    $thisMoment = date( "Y-m-d H:i:s", strtotime( "$previousHour +1 hour" ) );

	    $device = CustomerDevice::with('employee', 'customer')->find($id_device);
	    $customers = Customer::where('status', '=', 1)->get();

        $id_file = $request->input("id_file");
        $file = PathGraphic::with('varsf')->find($id_file);
        $fullFileName = $file->fileName;

        $registers = array();

        $file->startLine = $file['startLine'];
        $file->columns = $file['columns'];
        $file->formatDate = $file['formatDate'];
        $file->formatTime = $file['formatTime'];
        $file->separatorr = $file['separatorr'];
        $file->encoding = $file['encoding'];



        if($file->lastUpdate != null && $file->lastUpdate != ''){
            if($device->customer->timezone > 0)
                $device->customer->timezone = '+' . $device->customer->timezone;

            $thisMoment = date( "Y-m-d H:i:s", strtotime( $file->lastUpdate ." ". $device->customer->timezone." hour" ) );

            $file->lastUpdate = $thisMoment;

        }


	    if($serchCriteria['hour2'] != '') {
            $registers = $this->requestDataDevice($device->ip,
                $serchCriteria['date'],
                $serchCriteria['date2'], $fullFileName, $file->id,
                $file->startLine,
                $file->columns,
                $file->formatDate,
                $file->formatTime,
                $file->separatorr,
                $file->encoding);
        }


	    $dataToPrint = array();
	    $dataRanges = array();
	    $varNames = array();
	    $varSingleRange = array();
        $dataToPrint2 = array();
        $excededRecords = false;
        $errosOnFile = false;

        $noRegisters = 0;
        if(is_countable($registers))
            $noRegisters = count($registers);

	    if($noRegisters > 0 && $noRegisters <= 2000) {

            if(is_object($file->varsf) && $file->varsf->varRanges != ""){
                $varRanges = explode(',', $file->varsf->varRanges);
                foreach ($varRanges as $varRange) {
                    $varSingleRange[] = explode('-', $varRange);
                }

                $varNames = explode(',', $file->varsf->varNames);
            }




            if (count($registers) > 0 && $registers != 1001)
                foreach ($registers as $register) {

                    $dataLog = explode(";", $register);


                    if (preg_match('/ERROR*/', $dataLog[0])) {
                        $errosOnFile = true;
                        echo $dataLog[0];
                        continue;
                    }

                    if ($serchCriteria['chartType'] == 2) {
                        $dateTimeArray = explode(' ', $dataLog[0]);
                        $labels [] = $dateTimeArray[1];
                    }


                    $datas = explode('|', $dataLog[1]);
                    foreach ($datas as $index => $data) {

                        if ($data == "")
                            continue;

                        if (!isset($dataToPrint2[$index])) {
                            $dataToPrint2[$index] = array();
                            $dataToPrint2[$index][0] = array();
                            $dataToPrint2[$index][1] = array();
                            $dataToPrint2[$index][2] = array();
                        }

                        $dataToPrint2[$index][0][] = array('t' => strtotime($dataLog[0]), 'y' => trim($data));


                        if(is_object($file->varsf) && $file->varsf->varRanges != ""){
                            if (isset($varSingleRange[$index])) {


                                if($data < $varSingleRange[$index][0]){
                                    $this->insertRecordAlarm($dataLog[0], $data, $id_file, 1, $varSingleRange[$index][0], $index);
                                }else if($data > $varSingleRange[$index][1]){
                                    $this->insertRecordAlarm($dataLog[0], $data, $id_file, 2, $varSingleRange[$index][1], $index);
                                }

                                $dataToPrint2[$index][1][] = array('t' => strtotime($dataLog[0]), 'y' => $varSingleRange[$index][0]);
                                $dataToPrint2[$index][2][] = array('t' => strtotime($dataLog[0]), 'y' => $varSingleRange[$index][1]);
                            }
                        }

                    }
                }

            if ($serchCriteria['chartType'] == 1)
                $labels = $this->processData($initMinute, $lastMinute);
        }else if($noRegisters > 2000){
            $excededRecords = true;
        }

        $csrfToken = csrf_token();

	    return Response::json ( array (
	        'success' => true,
	        'device' => $device->toArray (),
	        'customers' => $customers->toArray (),
	        'dataToPrint' => $dataToPrint,
	        'dataToPrint2' => $dataToPrint2,
	        'lastRange' => $thisMoment,
	        'initRange' => $previousHour,
	        'labels' => $labels,
	        'dataRanges' => $dataRanges,
	        'varNames' => $varNames,
            'csrfToken' => $csrfToken,
            'excededRecords' => $excededRecords,
            'noRegisters' => $noRegisters,
            'file' => $file->toArray(),
            'errosOnFile' => $errosOnFile
	    ) );
	}

	public function asignDevice(Request $request){

	    $id_customer = $request->input("id_customer");
	    $id_device = $request->input("id_device");
	    $user = $request->input("user");



	    $device = CustomerDevice::find($id_device);
	    $device->id_customer = $id_customer;
	    $device->id_employee = $user['id'];
	    $device->save();


	    return Response::json ( array (
	        'success' => true
	    ) );

	}

	public function processData($initMinute, $lastMinute){

	    $labels = array();
	    for($x = 0; $x < $lastMinute; $x++){
	        $labels [] = ($x < 10) ? '0' + $x: $x;
	    }

	    return $labels;
	}


	public function saveData(Request $request){

	    $device = $request->input("device");

	    $deviceObj = CustomerDevice::find($device['id']);
	    $deviceObj->varNames = $device['varNames'];
	    $deviceObj->varRanges = $device['varRanges'];
	    $deviceObj->save();


	    return Response::json ( array (
	        'success' => true
	    ) );

	}

	public function setCustomerDeviceOnline(Request $request){

	    $user = $request->input('user');

	    $id_customer = $user['id'];
	    if(isset($user['id_customer'])){
	        $id_customer = $user['id_customer'];
	    }

	    $customer = Customer::find($id_customer);
	    $customer->onlineDateTime = date('Y-m-d H:i:s');
	    $customer->save();

	    return Response::json ( array (
	        'success' => true
	    ) );

	}

	public function isCustomerDeviceOnline(){

	    $currentDate = date("Y-m-d H:i:s", strtotime("-5 minutes"));
	    $customers = Customer::where('status', '=', 1)->where('onlineDateTime', '>=', $currentDate)->get();
	    $customersIDs = array();
	    if(count($customers) > 0)
	        foreach($customers as $customer){
	            $customersIDs[] = $customer->id;
	    }

	    $hmiDevices = CustomerDevice::where('status', '=', 1)->where('type', '=', 1)->where('ip', '!=', '')->where('user', '!=', '')->where('password', '!=', '')->whereIn('id_customer', $customersIDs)->get();
	    if(count($hmiDevices) > 0)
	        $hmiDevices = $hmiDevices->toArray();

	        return Response::json(array(
	            'success' => true,
	            'devicesOnline' => $hmiDevices
	        ));

	}


	public function getReportRegisters(Request $request){

		$initDate = $request->input('initDate');
		$initTime = $request->input('initTime');
		$finalDate = $request->input('finalDate');
		$ifinalTime = $request->input('finalTime');
		$id_device = $request->input('id_device');
        $id_file = $request->input('id_file');

        $pathObj = PathGraphic::find($id_file);

		$initialDate = $initDate . " " . $initTime . ':00';
		$finalDate = $finalDate . " " . $ifinalTime . ':00';

		$device = CustomerDevice::find($id_device);

        $registros = $this->requestDataDevice($device->ip, $initialDate, $finalDate, $pathObj->fileName, $pathObj->id,
            $pathObj->startLine,
            $pathObj->columns,
            $pathObj->formatDate,
            $pathObj->formatTime,
            $pathObj->separatorr,
            $pathObj->encoding);

		$excelElements = array();

		$fileName = public_path() . '/tmp/' . $pathObj->id . date('YmdHis') . '.csv';

		if($registros != "1001" && count($registros) > 0){
            $stringData = "";
		    foreach ($registros as $registro){
                $dataLog = explode(";", $registro);
                $fechaOrgArr = explode(" ", $dataLog[0]);
                $dataLog[1] = str_replace('|', ',', $dataLog[1]);
                $stringData .= $fechaOrgArr[0] . ',' . $fechaOrgArr[1] . ',' . $dataLog[1] .PHP_EOL;
		    }

            file_put_contents( $fileName, $stringData);

            return response()->download($fileName, $pathObj->fileName);

		}else{
		    echo "No hay registros";
        }


	}


	public function getAlerts(Request $request){

	    $searchAlerts = $request->input('searchAlerts');
	    $initDate = $searchAlerts['initDate'] . ' 00:00:00';
	    $endDate = $searchAlerts['endDate'] . ' 23:59:59';
        $id_file = $searchAlerts['id_file'];


	    $alerts = Event::where('id_file', '=', $id_file)->whereBetween('datetime', array($initDate, $endDate))->get();
	    if(count($alerts) > 0)
	        $alerts = $alerts->toArray();


	    return Response::json ( array (
	       'success' => true,
	        'alerts' => $alerts
	    ));

	}

	public function saveDevice(Request $request){
	    $device = $request->input('device');
        $user = $request->input('user');
        $duplicateIp = [];
        $deviceObj = array();
        $isNew = true;

	    if(isset($device['id'])){
            $duplicateIp = CustomerDevice::where('ip','=',$device['ip'])
                ->where('id','!=',$device['id'])->where('status','=', 1);

            if(isset($device['port']) && !empty($device['port']))
                $duplicateIp = $duplicateIp->where('port','=',$device['port']);

            $duplicateIp = $duplicateIp->get();

            $deviceObj = CustomerDevice::find($device['id']);
            $isNew = false;
        }else{
            $duplicateIp = CustomerDevice::where('ip','=',$device['ip']);
            if(isset($device['port']) && !empty($device['port']))
                $duplicateIp = $duplicateIp->where('port','=',$device['port']);

            $duplicateIp = $duplicateIp->get();

            $deviceObj = new CustomerDevice();
            $deviceObj->id_router = $device['id_router'];
            $deviceObj->id_customer = $device['id_customer'];
            $deviceObj->id_employee = $user['id'];
            $deviceObj->timestamp = date('Y-m-d H:i:s');
        }

        if(count($duplicateIp) > 0){
            return Response::json ( array (
                'success' => false,
                'duplicateIp' => true,
            ));
        }

	    $deviceObj->idDispositivo = $device['idDispositivo'];
	    $deviceObj->ip = $device['ip'];
	    $deviceObj->type = $device['type'];
	    $deviceObj->user = $device['user'];
        $deviceObj->label = $device['label'];
	    $deviceObj->password = $device['password'];
        $deviceObj->port = isset($device['port']) ? $device['port']:null;
        $deviceObj->idDispositivo = $device['idDispositivo'];
        $deviceObj->connectionType = $device['connectionType'];
        $deviceObj->timeout = isset ($device['timeout']) ? $device['timeout']:null;
        $deviceObj->idD = isset ($device['idD']) ? $device['idD']:null;
	    $deviceObj->status = 1;
	    $deviceObj->save();

        $deviceObj->paths();

	    return Response::json ( array (
	        'success' => true,
            'isNew' => $isNew,
            'device' => $deviceObj->toArray()
	    ));

	}

	public function saveVarData(Request $request){
	    $id_file = $request->input('id_file');
	    $varNameUpdate = $request->input('varNameUpdate');
	    $varRangesUpdate = $request->input('varRangesUpdate');

	    $deviceObj = PathGraphic::with('varsf')->find($id_file);
	    if(!is_object($deviceObj->varsf)){
	        $deviceFileVars = new DeviceFileVars();
            $deviceFileVars->id_file = $id_file;
        }else{
            $deviceFileVars = $deviceObj->varsf;
        }

        $deviceFileVars->varNames = $varNameUpdate;
        $deviceFileVars->varRanges = $varRangesUpdate;
        $deviceFileVars->save();

	    return Response::json ( array (
	        'success' => true
	    ));
	}

	public function getActiveHMI(){

	    $customers = Customer::where('status', '=', 1)->get();
	    $customersIDs = array();
	    if(count($customers) > 0)
	    foreach($customers as $customer){
	        $customersIDs[] = $customer->id;
	    }

	    $hmiDevices = CustomerDevice::where('status', '=', 1)->where('type', '=', 1)->where('ip', '!=', '')->where('user', '!=', '')->where('password', '!=', '')->whereIn('id_customer', $customersIDs)->get();
	    if(count($hmiDevices) > 0)
            $hmiDevices = $hmiDevices->toArray();

        return Response::json(array(
            'success' => true,
            'hmiDevices' => $hmiDevices
        ));
    }

    public function getActiveToPing()
    {
        $currentDate = date("Y-m-d H:i:s", strtotime("-5 minutes"));
        $customers = Customer::where('status', '=', 1)->where('onlineDateTime', '>=', $currentDate)->get();
        $customersIDs = array();
        if (count($customers) > 0)
            foreach ($customers as $customer) {
                $customersIDs[] = $customer->id;
            }

        $routers = Router::where('status', '=', 1)->whereIn('id_customer', $customersIDs)->get();
        $routersIDs = array();
        $devicesToPing = array();
        if (count($routers) > 0) {
            foreach ($routers as &$router) {
                $routersIDs[] = $router->id;
                $router->type = 1;
                $router->ip = $router->minIp;
	    }
	    $routers = $routers->toArray();
        }else{
            $routers = array();
        }

        if(count($routers) > 0){

            $devicesToPing = CustomerDevice::where('status', '=', 1)->where('type', '!=', 1)
            ->where('ip', '!=', '')
            ->whereIn('id_router', $routersIDs)
            ->get();
            if (count($devicesToPing) > 0) {
                foreach ($devicesToPing as &$deviceToPing) {
                    $deviceToPing->type = 2;
                }
                $devicesToPing = $devicesToPing->toArray();
            }else{
                $devicesToPing = array();
            }
        }

        $devicesToPing = array_merge ($routers, $devicesToPing);

	   return Response::json ( array (
	       'success' => true,
	       'devicesToPing' => $devicesToPing
	   ));

	}

	public function reportPingResults(Request $request){

	    $pingDevices = $request->input("pingedDevices");
	    $pingDevices = json_decode ($pingDevices);

	    foreach ($pingDevices as $pingDevice){
	        if($pingDevice->statusPing == 1){
	            if($pingDevice->deviceType == 1){
    	            $device = Router::find($pingDevice->id_device);
    	        }else{
    	            $device = CustomerDevice::find($pingDevice->id_device);
    	        }

    	        $device->lastPing = date('Y-m-d H:i:s');
    	        $device->save();
	        }
	    }


	    return Response::json ( array (
	        'success' => true
	    ));
	}

    public function doPing(Request $request){

        $ipAddress = $request->input('ipAddress');
        $requestArr = array('ipAddress' => $ipAddress);

        $response = $this->requestPostJsonServer($requestArr, '/ping');

        return Response::json ( array (
            'success' => true,
            'pingResult' => $response
        ));
    }


	public function test(){

	    $datetime1 = date_create("2019-05-24 03:00:00");
	    $datetime2 = date_create("now");

	    $interval = date_diff($datetime1, $datetime2);

	    echo ($interval->format("%h") * 60) + $interval->format("%i") . " | ";

	}

	public function requestDownloadFile(Request $request){

	    $id_device = $request->input("id_device");
        $id_file = $request->input("id_file");

        $file = PathGraphic::find($id_file);

	    $device = CustomerDevice::find($id_device);
	    $response = $this->requestFileServer($device->ip, $device->user, $device->password, $file->path, $file->fileName, $file->id,
            $file->startLine, $file->columns, $file->formatDate, $file->formatTime, $file->separatorr, $file->encoding);



	    if($response['isConnected'] == true){

            if($device->customer->timezone > 0)
                $device->customer->timezone = '+' . $device->customer->timezone;

            $response['lastUpdate'] = date( "Y-m-d H:i:s", strtotime( "now ". $device->customer->timezone." hour" ) );
            $file->lastUpdate = date('Y-m-d H:i:s');
            $file->save();

        }

        return Response::json ( $response );
    }

    public function requestFileServer($ipAddress, $user, $password, $path, $fileName, $id_file,
                                      $startLine, $columns, $formatDate, $formatTime, $separator, $encoding){

        $postData = array('ipAddress' => $ipAddress, 'user' => $user, 'password' => $password, 'path' => $path ,'fileName' => $fileName, 'id_file' => $id_file,
            'startLine' => $startLine, 'columns' => $columns, 'formatDate' => $formatDate, 'formatTime' => $formatTime, 'separator' => $separator, 'encoding' => $encoding);
        $url = "/recuperarArchivo";
        $response = $this->requestPostServer($postData, $url);

        $responseCode = substr($response, 0, 4);

        $isConnected = true;
        $fechasEnArchivo = "";
        $lastUpdate = "";
        $errorCode = 0;

        if($responseCode == "1001" || $responseCode == "1002" || $responseCode == "1003"
            || $responseCode == "1004" || $responseCode == "1005" || $responseCode == "1006" || $responseCode == "1021") {
            $isConnected = false;
            $errorCode = $response;
        }else{


            $postData = array('ipAddress' => $ipAddress, 'fileName' => $fileName, 'id_file' => $id_file,
                'startLine' => $startLine, 'columns' => $columns, 'formatDate' => $formatDate,
                'formatTime' => $formatTime, 'separator' => $separator, 'encoding' => $encoding);
            $url = "/getFileDates";

            $result = $this->requestPostServer($postData, $url);

            $dates = explode("|", $result);
            $fechasEnArchivo = array('fechaInicial' => $dates[0], 'fechaFinal' => $dates[1]);


            $lastUpdate = date('Y-m-d H:i:s');
        }

        return  array (
            'success' => true,
            'isConnected' => $isConnected,
            'errorCode' => $errorCode,
            'lastUpdate' => $lastUpdate,
            'fechasArchivo' => $fechasEnArchivo,
            'response' => $response
        );

    }

    public function verifyFile(Request $request){

        $id_device = $request->input("id_device");
        $id_file = $request->input("id_file");

        $file = PathGraphic::find($id_file);

        $device = CustomerDevice::find($id_device);
        $response = $this->fileExist($device->ip, $device->user, $device->password, $file->path, $file->fileName, $file->id);

        return Response::json ( array (
            'success' => true,
            'fileExist' => $response
        ));
    }

    public function fileExist($ipAddress, $user, $password, $path, $fileName, $id_file){

        $postData = array('ipAddress' => $ipAddress, 'user' => $user, 'password' => $password, 'path' => $path ,'fileName' => $fileName, 'id_file' => $id_file);
        $url = "/fileExist";
        $response = $this->requestPostServer($postData, $url);

        return $response;

    }

    public function requestDataDevice($ipAddress, $fechaInicio, $fechaFin, $fileName, $id_file,
                                        $startLine, $columns, $formatDate, $formatTime, $separator, $encoding){

        $postData = array('ipAddress' => $ipAddress, 'fechaInicio' => $fechaInicio, 'fechaFin' => $fechaFin, 'fileName' => $fileName, 'id_file' => $id_file,
            'startLine' => $startLine, 'columns' => $columns, 'formatDate' => $formatDate, 'formatTime' => $formatTime, 'separator' => $separator, 'encoding' => $encoding);

        $url = "/buscarDatos";

        return $this->requestPostJsonServer($postData, $url);

    }

    public function requestDatesFile(Request $request){

        $id_device = $request->input("id_device");
        $id_file = $request->input("id_file");

        $file = PathGraphic::find($id_file);
        $device = CustomerDevice::find($id_device);

        $postData = array('ipAddress' => $device->ip, 'fileName' => $file->fileName, 'id_file' => $id_file,
            'startLine' => $file->startLine, 'columns' => $file->columns, 'formatDate' => $file->formatDate,
            'formatTime' => $file->formatTime, 'separator' => $file->separatorr, 'encoding' => $file->encoding);
        $url = "/getFileDates";

        $result = $this->requestPostServer($postData, $url);

        $fechasEnArchivo = "";
        $fileExist = true;
        if($result == "1001") {
            $fileExist = false;
        }else{
            $dates = explode("|", $result);
            $fechasEnArchivo = array('fechaInicial' => $dates[0], 'fechaFinal' => $dates[1]);
        }

        return Response::json ( array (
            'success' => true,
            'fechaEnArchivo' => $fechasEnArchivo,
            'fileExist' => $fileExist
        ));

    }

    public function requestPostServer($postData, $url){

        $responseData = '';

        try {

            $settingsObj = Settings::find(1);
            $client = new Client(array('timeout' => 99999999, 'base_uri' => $settingsObj->server . ':' . $settingsObj->port));
            $response = $client->request('POST', '/Teratronix-1.2.0/api' . $url, [
                'form_params' => $postData
            ]);

            // Decode the response
            $result = $response->getBody()->getContents();
            $responseData = $result;

        } catch (\GuzzleHttp\Exception\ServerException $e) {
            $responseData = 1001;
        }

        return $responseData;

    }

    public function requestPostJsonServer($postData, $url){

        $responseData = '';

        try {
            $settingsObj = Settings::find(1);
            $client = new Client(array('timeout' => 99999999, 'base_uri' => $settingsObj->server . ':' . $settingsObj->port ));
            $response = $client->request('POST', '/Teratronix-1.2.0/api' . $url, [
                'form_params' => $postData
            ]);

            // Decode the response
            $result = $response->getBody()->getContents();
            $responseData = json_decode($result, TRUE);

        } catch (\GuzzleHttp\Exception\ServerException $e) {
            $responseData = 1001;
        }

        return $responseData;

    }

    public function savePath(Request $request){

	    $newPath = $request->input('newPath');

        $newPath['path'] = trim($newPath['path']);
        if(substr($newPath['path'], -1) == "/")
            $newPath['path'] = substr($newPath['path'], 0, -1);

        if(isset($newPath['id'])){
            $pathGraphic = PathGraphic::find($newPath['id']);
        }else{
            $pathGraphic = new PathGraphic();
        }

        $pathGraphic->id_customerDevice = $newPath['id_customerDevice'];
        $pathGraphic->path = $newPath['path'];
        $pathGraphic->fileName = $newPath['fileName'];
        $pathGraphic->label = $newPath['label'];
        $pathGraphic->startLine = $newPath['startLine'];
        $pathGraphic->columns = $newPath['columns'];
        $pathGraphic->formatDate = $newPath['formatDate'];
        $pathGraphic->formatTime = $newPath['formatTime'];
        $pathGraphic->separatorr = $newPath['separatorr'];
        $pathGraphic->encoding = $newPath['encoding'];
        $pathGraphic->save();

        return Response::json ( array (
            'success' => true,
            'newPath' => $pathGraphic->toArray()
        ));

    }


    public function deletePath(Request $request){

        $id_path = $request->input('id_path');

        PathGraphic::destroy($id_path);

        return Response::json ( array (
            'success' => true
        ));
    }

    public function getFileList(Request $request){

	    $id_device = $request->input('id_device');
        $user = $request->input('user');

        $filesList = PathGraphic::where('id_customerDevice','=', $id_device);

        if($user['type'] == 3){
            $userObj = User::find($user['id_user']);
            $pathsList = explode(',', $userObj->forPaths);
            $filesList->whereIn('id', $pathsList);
        }
	    $filesList = $filesList->get();

	    if(count($filesList) > 0)
	        $filesList = $filesList->toArray();

        return Response::json ( array (
            'success' => true,
            'filesList' => $filesList
        ));

    }

    private function insertRecordAlarm($dateTime, $value, $id_file, $type, $rangeData, $channel){

	    $eventTmp = Event::where('id_file', '=', $id_file)->where('datetime', '=', $dateTime)
            ->where('type', '=', $type)->where('channel', '=', $channel)->first();

	    if(!is_object($eventTmp)) {
            $eventObj = new Event();
            $eventObj->id_file = $id_file;
            $eventObj->datetime = $dateTime;
            $eventObj->type = $type;
            $eventObj->rangeData = $rangeData;
            $eventObj->value = $value;
            $eventObj->channel = $channel;
            $eventObj->save();
        }

    }

    public function doPingServer(Request $request){

        $server = $request->input("server");
        $server = str_replace('/', '', $server);
        $server = str_replace('http:', '', $server);
        $server = str_replace('https:', '', $server);

        $requestArr = array('ipAddress' => $server);
        $response = $this->requestPostJsonServer($requestArr, '/ping');

        return Response::json ( array (
            'success' => true,
            'resultPing' => $response
        ));
    }

    public function saveFileConfig(Request $request){

        $file = $request->input("file");

        $fileObj = PathGraphic::find($file['id']);
        $fileObj->startLine = $file['startLine'];
        $fileObj->columns = $file['columns'];
        $fileObj->formatDate = $file['formatDate'];
        $fileObj->formatTime = $file['formatTime'];
        $fileObj->separatorr = $file['separatorr'];
        $fileObj->encoding = $file['encoding'];
        $fileObj->save();

        return Response::json ( array (
            'success' => true
        ));
    }

    public function downloadFile(Request $request){

        $fileName = $request->input("fileName");
        $id_file = $request->input("id_file");
        $ipAddress = $request->input("ipAddress");

        $newURL = "http://tunelrouter.ddns.net:8086/Teratronix-1.2.0/api/download?ipAddress=$ipAddress&id_file=$id_file&fileName=" . urlencode("$fileName");

        $str = file_get_contents($newURL);


        header('Content-Disposition: attachment; filename="'.$fileName.'"');
        header('Content-Type: text/csv'); # Don't use application/force-download - it's not a real MIME type, and the Content-Disposition header is sufficient
        header('Content-Length: ' . strlen($str));
        header('Connection: close');

        echo $str;
    }

    public function addAlarm(Request $request){

        $id_deviceplc = $request->input("id_deviceplc");
        Log::info("addAlarm: " + $id_deviceplc);

        return Response::json ( array (
            'success' => true
        ));

    }

    public function saveActivateBackupConfig(Request $request){

        $backupConfig = $request->input("backupConfig");

        $pathFile = PathGraphic::find($backupConfig['id_file']);
        $pathFile->activateBackups = $backupConfig['activateBackups'];
        $pathFile->save();

        return Response::json ( array (
            'success' => true
        ));

    }

    public function saveBackupsConfig(Request $request){

        $backupConfig = $request->input("backupConfig");
        $pathFile = PathGraphic::find($backupConfig['id_file']);
        $pathFile->periodicity = $backupConfig['periodicity'];
        $pathFile->value = $backupConfig['value'];
        $pathFile->time = $backupConfig['time'];


        $nextDate = Utils::getNextRetryDate($pathFile);

        $pathFile->nextRetry = $nextDate;
        $pathFile->save();

        return Response::json ( array (
            'success' => true
        ));

    }
}
