<?php
namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Input;
use Illuminate\Support\Facades\Response;
use Illuminate\Support\Facades\DB;
use App\Models\CustomerDevice;
use App\Models\Employee;
use App\Models\Customer;
use App\Models\Event;
use App\Models\LoginRecord;
use App\Models\Registro;
use App\Models\User;
use App\Console\Utils;
use Illuminate\Routing\Controller as BaseController;

class EmployeesController extends BaseController
{

    public function getEmployees()
    {
        $employees = Employee::where("status", "=", 1)->get();

        return Response::json(array(
            'success' => true,
            'employees' => $employees->toArray()
        ));
    }

    public function getEmployee(Request $request)
    {
        $id_employee = $request->input("id_employee");
        $employee = Employee::find($id_employee);

        return Response::json(array(
            'success' => true,
            'employee' => $employee->toArray()
        ));
    }

    public function saveEmployee(Request $request)
    {
        $employee = $request->input("employee");

        if (isset($employee['id']) && $employee['id'] > 0) {
            $employeeObj = Employee::find($employee['id']);
        } else {
            $employeeObj = new Employee();
        }

        $token = rand(111111111111, 999999999999);

        $employeeObj->name = $employee['name'];
        $employeeObj->user = $employee['user'];
        $employeeObj->password = $employee['password'];
        $employeeObj->email = $employee['email'];
        $employeeObj->phone = $employee['phone'];
        $employeeObj->image = $employee['image'];
        $employeeObj->type = $employee['type'];
        $employeeObj->token = $token;
        $employeeObj->status = 1;
        $employeeObj->save();

        return Response::json(array(
            'success' => true,
            'employee' => $employeeObj->toArray()
        ));
    }

    public function deleteEmployee(Request $request)
    {
        $id_employee = $request->input("id_employee");

        Employee::where('id', '=', $id_employee)->update(array(
            'status' => 0
        ));

        return Response::json(array(
            'success' => true
        ));
    }

    public function login(Request $request)
    {
        $user = $request->input('user');

        $userObj = Employee::where('user', '=', $user['user'])->where('password', '=', $user['password'])->first();

        $token = "";
        $tipo = "";
        $id = "";
        $type = 0;
        $logo = "";
        $id_user = '';
        $homeImg = '';
        $permissions = array('forHmi', 'forAlers', 'forRouters', 'forConfig', 'forUserData', 'forPLC');

        $isValid = false;
        if (is_object($userObj) && $userObj->id > 0) {
            $isValid = true;
            $token = $userObj->token;
            $tipo = $userObj->type;
            $id = $userObj->id;
            $type = 1;
        } else {

            $customer = Customer::where('email', '=', $user['user'])->where('password', '=', $user['password'])->first();

            if (is_object($customer) && $customer->id > 0) {

                $token = Utils::randomPass(15);


                $isValid = true;
                $id = $customer->id;
                $logo = $customer->logo;
                $homeImg = $customer->homeImg;
                $type = 2;

                $login = new LoginRecord();
                $login->id_customer = $customer->id;
                $login->fechaInicio = date('Y-m-d H:i:s');
                $login->save();

                $customer->token = $token;
                $customer->save();

            }else{

                $user = User::where('mail', '=', $user['user'])->where('password', '=', $user['password'])->first();

                if (is_object($user) && $user->id > 0) {
                    $customer = Customer::find($user->id_customer);

                    $token = $customer->token;

                    $isValid = true;
                    $id = $customer->id;
                    $logo = $customer->logo;
                    $homeImg = $customer->homeImg;
                    $type = 3;
                    $id_user = $user->id;

                    $permissions['forHmi'] = explode(",", $user->forHmi);
                    $permissions['forAlers'] = explode(",", $user->forAlers);
                    $permissions['forRouters'] = explode(",", $user->forRouters);
                    $permissions['forConfig'] = explode(",", $user->forConfig);
                    $permissions['forUserData'] = explode(",", $user->forUserData);
                    $permissions['forPLC'] = explode(",", $user->forPLC);
                    $permissions['forWorkSheets'] = explode(",", $user->forWorkSheets);

                    $login = new LoginRecord();
                    $login->id_customer = $customer->id;
                    $login->fechaInicio = date('Y-m-d H:i:s');
                    $login->id_user = $user->id;
                    $login->save();
                }

            }
        }

        return Response::json(array(
            'success' => true,
            'login' => $isValid,
            'token' => $token,
            'tipo' => $tipo,
            'id' => $id,
            'type' => $type,
            'logo' => $logo,
            'homeImg' => $homeImg,
            'id_user' => $id_user,
            'permissions' => $permissions
        ));
    }

    public function getMenu(Request $request)
    {
        $type = $request->input('type');
        $id_user = $request->input('id_user');

        if ($type == 1) {

            $menu = array(
                array(
                    "text" => "Navegación Principal",
                    "heading" => "true"
                ),
                array(
                    "text" => "Bienvenido",
                    "sref" => "#",
                    "icon" => "icon-home"
                ),
                array(
                    "text" => "Usuarios",
                    "sref" => "app.employees",
                    "icon" => "icon-user"
                ),
                array(
                    "text" => "Clientes",
                    "sref" => "app.customers",
                    "icon" => "icon-people"
                ),
                array(
                    "text" => "Monitoreo Remoto",
                    "sref" => "app.devices",
                    "icon" => "icon-eye"
                ),
                array(
                    "text" => "Registros PLC",
                    "sref" => "app.plcs",
                    "icon" => "fa fa-qrcode"
                ),
                array(
                    "text" => "Historial login",
                    "sref" => "app.login-historic",
                    "icon" => "icon-login"
                ),

                array(
                    "text" => "Routers",
                    "sref" => "app.routers",
                    "icon" => "fa fa-hdd-o"
                ),
                array(
                    "text" => "Historial VPN",
                    "sref" => "app.download-vpn-logs",
                    "icon" => "fa fa-code-fork"
                ),
                array(
                    "text" => "Alertas SMS",
                    "sref" => "app.sms-alerts",
                    "icon" => "fa fa-exclamation-triangle"
                ),
                array(
                    "text" => "Hojas de trabajo",
                    "sref" => "app.worksheets",
                    "icon" => "fa fa-file-text-o"
                ),
                array(
                    "text" => "Configuraciones",
                    "sref" => "app.settingsCustom",
                    "icon" => "icon-settings"
                ),
                array(
                    "text" => "Ayuda",
                    "sref" => "app.help",
                    "icon" => "icon-question"
                )

            );
        } else if ($type == 2) {

            $menu = array(
                array(
                    "text" => "Navegación Principal",
                    "heading" => "true"
                ),
                array(
                    "text" => "Home",
                    "sref" => "app.home",
                    "icon" => "icon-home"
                ),
                array(
                    "text" => "Cuenta",
                    "sref" => "app.myprofile",
                    "icon" => "icon-support"
                ),
                array(
                    "text" => "Monitoreo Remoto",
                    "sref" => "app.devicesCustomer",
                    "icon" => "icon-eye"
                ),
                array(
                    "text" => "Mis Routers",
                    "sref" => "app.routers",
                    "icon" => "fa fa-hdd-o"
                ),
                array(
                    "text" => "Registros PLC",
                    "sref" => "app.plcs",
                    "icon" => "fa fa-qrcode"
                ),
                array(
                    "text" => "Hojas de trabajo",
                    "sref" => "app.worksheets",
                    "icon" => "fa fa-file-text-o"
                ),
                array(
                    "text" => "Historial login",
                    "sref" => "app.login-historic",
                    "icon" => "icon-login"
                ),
                array(
                    "text" => "Usuarios",
                    "sref" => "app.configurations",
                    "icon" => "icon-people"
                ),
                array(
                    "text" => "Ayuda",
                    "sref" => "app.help",
                    "icon" => "icon-question"
                )
            );
        }else if ($type == 3) {

            $id_user = $request->input('id');
            $user = User::find($id_user);

            $menu = array();

            $permissionsHMI = explode(",", $user->forHmi);
            $permissionsforRouters = explode(",", $user->forRouters);
            $permissionsforConfig = explode(",", $user->forConfig);
            $permissionsforUserData = explode(",", $user->forUserData);
            $permissionsforPLC = explode(",", $user->forPLC);
            $permissionsforHelp = explode(",", $user->forHelp);
            $permissionsforWorkSheets = explode(",", $user->forWorkSheets);

            $menu [] = array(
                "text" => "Navegación Principal",
                "heading" => "true"
            );

            $menu [] = array(
                "text" => "Home",
                "sref" => "app.home",
                "icon" => "icon-home"
            );

            $menu [] = array(
                "text" => "Mis datos",
                "sref" => "app.subuser-data",
                "icon" => "icon-user"
            );

            if($permissionsHMI[0] == 1){
                $menu[] = array(
                    "text" => "Monitoreo Remoto",
                    "sref" => "app.devicesCustomer",
                    "icon" => "icon-eye"
                );
            }

            if($permissionsforPLC[0] == 1){
                $menu[] = array(
                    "text" => "Registros PLC",
                    "sref" => "app.plcs",
                    "icon" => "fa fa-qrcode"
                );
            }


            if($permissionsforRouters[0] == 1){
                $menu[] = array(
                    "text" => "Mis Routers",
                    "sref" => "app.routers",
                    "icon" => "fa fa-hdd-o"
                );
            }

            if($permissionsforWorkSheets[0] == 1){
                $menu[] = array(
                    "text" => "Hojas de trabajo",
                    "sref" => "app.worksheets",
                    "icon" => "fa fa-file-text-o"
                );
            }

            if($permissionsforConfig[0] == 1){
                $menu[] = array(
                    "text" => "Usuarios",
                    "sref" => "app.configurations",
                    "icon" => "icon-people"
                );
            }


            if($permissionsforUserData[0] == 1){
                $menu[] = array(
                    "text" => "Cuenta",
                    "sref" => "app.myprofile",
                    "icon" => "icon-support"
                );
            }

            if($permissionsforHelp[0] == 1){
                $menu[] = array(
                    "text" => "Ayuda",
                    "sref" => "app.help",
                    "icon" => "icon-question"
                );
            }


        }

        echo json_encode($menu);
    }

    public function updateLastLoginActivity(Request $request)
    {
        $user = $request->input('user');

        $loginRecord = LoginRecord::where('id_customer', '=', $user['id'])->orderBy('fechaInicio', 'desc')->first();
        $loginRecord->fechaFin = date('Y-m-d H:i:s');
        $loginRecord->save();

        return Response::json(array(
            'success' => true
        ));
    }

    public function test(Request $request)
    {
        $next = $request->input('next');

        $registros = Registro::where('id_device', '=', 48)->orderBy('datetime')
            ->skip($next)
            ->take(2000)
            ->get();

        $currentDate = '';
        $deleteElements = array();
        foreach ($registros as $registro) {

            if ($currentDate == $registro->datetime) {
                $deleteElements[] = $registro->id;
            } else {
                $currentDate = $registro->datetime;
            }
        }

        Registro::destroy($deleteElements);

        $next += 500;

        echo "<!DOCTYPE html>
<html>
<header>
<script>
function myFunction() {
	window.location.href = 'http://sistema.teratronix.com/api/admin/employees/test?next=" . $next . "';
}
</script>
</header>
<body onload='myFunction()'>



</body>
</html>
";
    }

    public function processEvents()
    {
        $devicesToProcess = CustomerDevice::where('status', '=', 1)->get();

        foreach ($devicesToProcess as $deviceToProcess) {

            if (! empty ($deviceToProcess->varRanges)) {

                $ranges = explode(',', $deviceToProcess->varRanges);
                foreach ($ranges as &$range) {
                    $rangeData = explode('-', $range);
                    $range = $rangeData;
                }

                $toDate = date('Y-m-d H:i:s');
                $fromDate = date("Y-m-d H:i:s", strtotime("-4 hours"));
                $registros = Registro::where('id_device', '=', $deviceToProcess->id)->whereBetween('datetime', array(
                    $fromDate,
                    $toDate
                ))->get();

                foreach ($registros as $registro) {

                    $datos = explode(',', $registro->data);

                    foreach ($datos as $index => $dato) {

                        if (isset($ranges[$index])) {
                            $isOk = true;
                            $errorType = 0;
                            $rangeData = 0;

                            if ($dato < $ranges[$index][0]) {
                                $isOk = false;
                                $errorType = 1;
                                $rangeData = $ranges[$index][0];
                            } else if ($dato > $ranges[$index][1]) {
                                $isOk = false;
                                $errorType = 2;
                                $rangeData = $ranges[$index][1];
                            }

                            if ($isOk == false) {

                                $eventObject = Event::where('id_device', '=', $deviceToProcess->id)->where('datetime', '=', $registro->datetime)
                                    ->where('subType', '=', $errorType)
                                    ->first();

                                if (!is_object($eventObject)) {

                                    $event = new Event();
                                    $event->id_device = $deviceToProcess->id;
                                    $event->datetime = $registro->datetime;
                                    $event->state = 1;
                                    $event->type = 1;
                                    $event->subType = $errorType;
                                    $event->rangeData = $rangeData;
                                    $event->value = $dato;
                                    $event->save();
                                }
                            }
                        } else {
                            break;
                        }
                    }
                }
            }

            $deviceToProcess->pendingProcess = 0;
            $deviceToProcess->save();
        }
    }
}
