<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Input;
use Illuminate\Support\Facades\Response;
use Illuminate\Routing\Controller as BaseController;

use App\Models\Product;

class ProductsController extends BaseController {

	public function getProducts(){

		$products = Product::where("status", "=", 1)->get();

		return Response::json ( array (
				'success' => true,
				'products' => $products->toArray()
		) );
	}

	public function getProduct(Request $request){

		$id_product = $request->input("id_product");
		$product = Product::find($id_product);

		if($product->isImported == 1){
			$product->isImported = true;
		}else{
			$product->isImported = false;
		}

		if($product->isSpecial == 1){
			$product->isSpecial = true;
		}else{
			$product->isSpecial = false;
		}


		return Response::json ( array (
				'success' => true,
				'product' => $product->toArray()
		) );
	}

	public function saveProduct(Request $request){

		$product = $request->input("product");

		if (isset($product['id']) && $product['id'] > 0){
			$productObj = Product::find($product['id']);
		}else{
			$productObj = new Product();
		}

		$isImported = (isset($product['isImported'])) ? $product['isImported'] : 0;
		if($isImported == 'true' || $isImported == '1 '){
			$isImported = 1;
		}else{
			$isImported = 0;
		}

		$isSpecial = (isset($product['isSpecial'])) ? $product['isSpecial'] : 0;
		if($isSpecial == 'true' || $isSpecial == '1 '){
			$isSpecial = 1;
		}else{
			$isSpecial = 0;
		}

		$productObj->name = $product['name'];
		$productObj->code = (isset($product['code'])) ? $product['code'] : '';
		$productObj->price1 = (isset($product['price1'])) ? $product['price1'] : '';
		$productObj->price2 = (isset($product['price2'])) ? $product['price2'] : '';
		$productObj->price3 = (isset($product['price3'])) ? $product['price3'] : '';
		$productObj->weight = (isset($product['weight'])) ? $product['weight'] : '';
		$productObj->isImported = $isImported;
		$productObj->isSpecial = $isSpecial;
		$productObj->status = 1;
		$productObj->save();

		return Response::json (array (
				'success' => true,
				'product' => $productObj->toArray()
		));
	}

	public function deleteProduct(Request $request){

		$id_product = $request->input("id_product");

		Product::where('id', '=', $id_product)->update(array('status' => 0));

		return Response::json (array (
				'success' => true
		));

	}



}
