<?php
namespace App\Http\Controllers;

use App\Console\Utils;
use App\Models\CustomerDevice;
use App\Models\Router;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Input;
use Illuminate\Support\Facades\Response;
use Illuminate\Routing\Controller as BaseController;

class RoutersController extends BaseController {


    public function saveRouter(Request $request){


        $router = $request->input('router');
        $user = $request->input('user');

        $routerObj = new Router();
        $routerObj->id_customer = $router['id_customer'];
        $routerObj->name = $router['name'];
        $routerObj->minIp = $router['minIp'];
        $routerObj->maxIp = $router['maxIp'];
        $routerObj->id_employee = $user['id'];
        $routerObj->dateCreation = date('Y-m-d');
        $routerObj->isEnabled = 1;
        $routerObj->status = 1;
        $routerObj->save();

        $ipSegment = explode('.', $router['minIp']);

        //$newIP = $ipSegment[3];
//        for($x = 0; $x < 10; $x++){
//
//            $newIP += 1;
//            $device = new CustomerDevice();
//            $device->id_customer = $router['id_customer'];
//            $device->id_router = $routerObj->id;
//            $device->idDispositivo = 'No asignado';
//            $device->id_employee = $user['id'];
//            $device->ip = $ipSegment[0] . '.' . $ipSegment[1]. '.'  . $ipSegment[2]. '.'  . $newIP;
//            $device->isOnline = 0;
//            $device->status = 0;
//            $device->save();
//
//        }

        $routerRt = Router::with('devices')->find($routerObj->id);
        $routerRt->isEnabled .='';

        return Response::json ( array (
            'success' => true,
            'router' => $routerRt->toArray()
        ) );

    }

    public function updateRouter(Request $request){


        $router = $request->input('router');

        $routerObj = Router::find($router['id']);
        $routerObj->name = $router['name'];
        $routerObj->minIp = $router['minIp'];
        $routerObj->maxIp = $router['maxIp'];
        $routerObj->isEnabled = $router['isEnabled'];
        $routerObj->save();

        return Response::json ( array (
            'success' => true
        ) );

    }

    public function getRoutersByCustomer(Request $request){

        $id_customer = $request->input('id_customer');
        $user = $request->input('user');

        if($user['type'] == 2){
            $id_customer = $user['id'];
        }

        $routers = Router::where('status', '=', 1);

        if($id_customer > 0){
            $routers = $routers->where('id_customer', '=', $id_customer);
        }

        $routers = $routers->get();


        if(count($routers) > 0){
            foreach($routers as &$router){
                $noActiveDevices = CustomerDevice::where('id_router', '=', $router->id)->where('status', '=', 1)->where('ip', '=', '')->count();
                $router->noActiveDevices = $noActiveDevices;

                $to_time = strtotime("now");
                $from_time = strtotime($router->lastPing);
                if(round(abs($to_time - $from_time) / 60,2) < 2){
                    $router->isReachable = 1;
                }else{
                    $router->isReachable = 0;
                }

            }
            $routers = $routers->toArray();
        }


        return Response::json ( array (
            'success' => true,
            'routers' => $routers
        ) );

    }

    public function getRouteSito(Request $request){

        $id_route = $request->input('id_router');

        $routerRt = Router::with('devices.paths')->find($id_route);
        $routerRt->isEnabled .='';

        if(count($routerRt->devices) > 0)
        foreach($routerRt->devices as &$device){

            $to_time = strtotime("now");
            $from_time = strtotime($device->lastPing);
            if(round(abs($to_time - $from_time) / 60,2) < 2){
                $device->isReachable = 1;
            }else{
                $device->isReachable = 0;
            }
        }

        $deviceTypes = Utils::$DEVICE_TYPE;

        return Response::json ( array (
            'success' => true,
            'router' => $routerRt->toArray(),
            'deviceTypes' => $deviceTypes
        ) );
    }

}

