<?php

namespace App\Http\Controllers;

use App\Models\Settings;
use App\Models\SupportFile;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Input;
use Illuminate\Support\Facades\Response;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Mail;
use Illuminate\Routing\Controller as BaseController;

use App\Models\Quotation;


class SettingsController extends BaseController
{
    public function getSettings()
    {

        $settingsObj = Settings::find(1);

        return Response::json(array(
            'success' => true,
            'settings' => $settingsObj->toArray()
        ));
    }

    public function saveSettings(Request $request)
    {

        $settings = $request->input('settings');

        $settingsObj = Settings::find(1);
        $settingsObj->server = $settings['server'];
        $settingsObj->port = $settings['port'];
        $settingsObj->emailNotifications = $settings['emailNotifications'];
        $settingsObj->save();

        return Response::json(array(
            'success' => true
        ));
    }


    public function saveDoc(Request $request)
    {

        $docFile = $request->file('file');
        //$description = $request->input('description');


        $extention = strtolower($docFile->getClientOriginalExtension());
        $fileName = "docs" . date('YmdHis') . "." . $extention;
        $originalName = $docFile->getClientOriginalName();

        $up1Success = $docFile->move('docs/', $fileName);
        $isExito = false;
        $docFile = '';
        if ($up1Success) {
            $isExito = true;

            $file = new SupportFile();
            $file->fileName = $fileName;
            $file->originalName = $originalName;
            $file->status = 1;
            $file->datetime = date('Y-m-d H:i:s');
            $file->extention = $extention;
            $file->save();

            $docFile = $file->toArray();
        }

        return Response::json(array(
            'success' => true,
            'isExito' => $isExito,
            'docFile' => $docFile
        ));

    }


    public function deleteDoc(Request $request)
    {
        $id_doc = $request->input('id_doc');

        $file = SupportFile::find($id_doc);
        $file->status = 0;
        $file->save();

        return Response::json(array(
            'success' => true
        ));

    }

    public function getDocList(){

        $files = SupportFile::where('status', '=', 1)->get();
        if(count($files) > 0)
            $files = $files->toArray();


        return Response::json(array(
            'success' => true,
            'listDocs' => $files,
            'csrf' => csrf_token()
        ));
    }

    public function downloadFile(Request $request){

        $id_doc = $request->input('id');
        $file = SupportFile::find($id_doc);

        $fileName = "docs/" . $file->fileName;
        $mimeType = \mime_content_type($fileName);

        $headers = array(
            "Content-Type: $mimeType"
        );

        return Response::download($fileName, $file->originalName, $headers);
    }


}

