<?php
namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Response;
use Illuminate\Routing\Controller as BaseController;

use App\Models\Employee;
use App\Models\Task;
use Illuminate\Support\Facades\Input;
use App\Models\Comment;

class TasksController extends BaseController {

	public function getTasks(Request $request) {

		$filter = $request->input('filter');
		$user = $request->input('user');

		if($user['tipo'] != 1){
			$filter['id_employee'] = $user['id'];
		}

		$tasks = Task::where ( "status", "=", 1 );

		if($filter['id_employee'] > 0){
			$tasks->where('id_employee', '=', $filter['id_employee']);
		}

		$tasks = $tasks->with ( 'employee', 'comments.employee' )->where('status', '=', 1)->orderBy('dateStart')->get ();

		$employees = Employee::where("status", "=", 1)->get();

		$today = new \DateTime ();

		$currentDate = "";
		$tasksArray = array();
		if(count($tasks) > 0)
		foreach ($tasks as $task){

			if($currentDate != $task->dateStart){
				$tasksArray[] = array('type' => 1, 'date' => $task->dateStart, 'bg' => "bg-gray");
				$currentDate = $task->dateStart;
			}


			$dateFinish = new \DateTime ( $task->dateFinish );
			if($dateFinish < $today && $task->taskStatus != 2){
				$task->bg = "warningTask";
			}

			$tasksArray[] = $task->toArray();

		}

		return Response::json ( array (
				'success' => true,
				'tasks' => $tasksArray,
				'employees' => $employees->toArray()
		) );
	}


	public function saveTask(Request $request){

		$task = $request->input('task');
		$user = $request->input('user');

		$initial = $task['dateStart'];
		$final = $task['dateFinish'];

		$initial = explode(" ", $initial);
		$initial = $initial[0] . " 00:00:00";

		$final = explode(" ", $final);
		$final = $final[0] . " 23:59:59";

		$finalDateTime = new \DateTime ( $final );

		$currentDate = $initial;
		$x = 0;
		$id_originTask = 0;
		$taskObjRet = null;

		if(isset($task['id'])){
			$taskObj = Task::find($task['id']);

			$taskObj->id_employee = $task['id_employee'];
			$taskObj->id_employeeCreation = $user['id'];
			$taskObj->title = $task['title'];
			$taskObj->description = $task['description'];
			$taskObj->dateStart = $task['dateStart'];
			$taskObj->dateFinish = $task['dateFinish'];
			$taskObj->time = $task['time'];
			$taskObj->taskStatus = $task['taskStatus'];
			$taskObj->subType = $task['subType'];
			$taskObj->status = 1;
			$taskObj->save();
			$taskObjRet = $taskObj;

			if(isset($task['comment']) && trim($task['comment']) != ""){

				$comment = new Comment();
				$comment->id_task = $taskObj->id;
				$comment->id_employee = $user['id'];
				$comment->text = trim($task['comment']);
				$comment->status = 1;
				$comment->save();
			}


		}else{

			if($task['subType'] == 1){


				$taskObj = new Task();
				$taskObj->dateCreation = date('Y-m-d H:i:s');
				$taskObj->id_employee = $task['id_employee'];
				$taskObj->id_employeeCreation = $user['id'];
				$taskObj->title = $task['title'];
				$taskObj->description = $task['description'];
				$taskObj->dateStart = $task['dateStart'];
				$taskObj->dateFinish = $task['dateFinish'];
				$taskObj->time = $task['time'];
				$taskObj->taskStatus = $task['taskStatus'];
				$taskObj->subType = $task['subType'];
				$taskObj->status = 1;
				$taskObj->save();
				$taskObjRet = $taskObj;

				if(isset($task['comment']) && trim($task['comment']) != ""){

					$comment = new Comment();
					$comment->id_task = $taskObj->id;
					$comment->id_employee = $user['id'];
					$comment->text = trim($task['comment']);
					$comment->status = 1;
					$comment->save();
				}


			}else
			if($task['subType'] == 2){

				$canContinue = true;

				$nextDateStart = strtotime($task['dateStart']);
				$eventStartAt = strtotime($task['dateStart']);

				while($canContinue){


					$taskObj = new Task();
					$taskObj->dateCreation = date('Y-m-d H:i:s');
					$taskObj->id_employee = $task['id_employee'];
					$taskObj->id_employeeCreation = $user['id'];
					$taskObj->title = $task['title'];
					$taskObj->description = $task['description'];
					$taskObj->time = $task['time'];
					$taskObj->taskStatus = $task['taskStatus'];
					$taskObj->subType = $task['subType'];
					$taskObj->status = 1;
					$taskObj->dateStart = $currentDate = date('Y-m-d H:i:s', $nextDateStart);
					$taskObj->dateFinish = date('Y-m-d H:i:s', strtotime("+1 hour", $nextDateStart));
					$taskObj->id_originTask = $id_originTask;

					$fechaThisTask = new \DateTime ( $currentDate );

					if($fechaThisTask > $finalDateTime ){
						$canContinue = false;
					}else{
						$taskObj->save();
						$taskObjRet = $taskObj;
					}

					$now = strtotime($currentDate);
					$nextDateStart = strtotime("next ".date('l', $eventStartAt)." " . date('H:i:s', $eventStartAt), $now);

					if($x == 0)
						$id_originTask = $taskObj->id;

					$x++;

				}
			}else
			if($task['subType'] == 3){

				$eventStartAt = strtotime($task['dateStart']);
				$now = strtotime($eventStartAt);
				$partial =explode (' ', $task['dateStart']);
				$time = trim($partial[1]);
				$date =explode ('-', $partial[0]);

				$year = $date[0];
				$month = $date[1];
				$day = $date[2];

				$canContinue = true;

				while($canContinue){

					$taskObj = new Task();
					$taskObj->dateCreation = date('Y-m-d H:i:s');
					$taskObj->id_employee = $task['id_employee'];
					$taskObj->id_employeeCreation = $user['id'];
					$taskObj->title = $task['title'];
					$taskObj->description = $task['description'];
					$taskObj->time = $task['time'];
					$taskObj->taskStatus = $task['taskStatus'];
					$taskObj->subType = $task['subType'];
					$taskObj->status = 1;
					$taskObj->dateStart = "$year-$month-$day $time";
					$taskObj->dateFinish = "$year-$month-".($day+1). " $time";
					$taskObj->id_originTask = $id_originTask;
					$taskObj->save();

					if($x == 0)
						$id_originTask = $taskObj->id;

						$x++;


					$taskObj = new Task();
					$taskObj->dateCreation = date('Y-m-d H:i:s');
					$taskObj->id_employee = $task['id_employee'];
					$taskObj->id_employeeCreation = $user['id'];
					$taskObj->title = $task['title'];
					$taskObj->description = $task['description'];
					$taskObj->time = $task['time'];
					$taskObj->taskStatus = $task['taskStatus'];
					$taskObj->subType = $task['subType'];
					$taskObj->status = 1;
					$taskObj->dateStart = "$year-$month-".($day+14). " $time";
					$taskObj->dateFinish = "$year-$month-".($day+14). " 19:00:00";
					$taskObj->id_originTask = $id_originTask;

					if($month == 12){
						$month = 1;
						$year++;
					}else{
						$month++;
					}

					$fechaThisTask = new \DateTime ( "$year-$month-".($day+14). " $time" );

					if($fechaThisTask > $finalDateTime ){
						$canContinue = false;
					}else{
						$taskObj->save();
						$taskObjRet = $taskObj;
					}


				}

			}else
			if($task['subType'] == 4){

				$eventStartAt = strtotime($task['dateStart']);
				$now = strtotime($eventStartAt);
				$partial =explode (' ', $task['dateStart']);
				$time = trim($partial[1]);
				$date =explode ('-', $partial[0]);

				$year = $date[0];
				$month = $date[1];
				$day = $date[2];

				$canContinue = true;

				while($canContinue){

					$taskObj = new Task();
					$taskObj->dateCreation = date('Y-m-d H:i:s');
					$taskObj->id_employee = $task['id_employee'];
					$taskObj->id_employeeCreation = $user['id'];
					$taskObj->title = $task['title'];
					$taskObj->description = $task['description'];
					$taskObj->dateFinish = $task['dateFinish'];
					$taskObj->time = $task['time'];
					$taskObj->taskStatus = $task['taskStatus'];
					$taskObj->subType = $task['subType'];
					$taskObj->status = 1;
					$taskObj->dateStart = "$year-$month-$day $time";
					$taskObj->dateFinish = "$year-$month-$day 19:00:00";
					$taskObj->id_originTask = $id_originTask;
					$taskObj->save();


					if($month == 12){
						$month = 1;
						$year++;
					}else{
						$month++;
					}

					$fechaThisTask = new \DateTime ( "$year-$month-$day $time" );

					if($fechaThisTask > $finalDateTime ){
						$canContinue = false;
					}else{
						$taskObj->save();
						$taskObjRet = $taskObj;
					}

					if($x == 0)
						$id_originTask = $taskObj->id;

						$x++;


				}

			}



		}



		return Response::json ( array (
				'success' => true,
				'task' => $taskObjRet->toArray()
		) );


	}

	public function deleteTask(Request $request){

		$task = $request->input('task');

		Task::where('id', '=', $task['id'])->update(array('status' => 0));

		if($task['id_originTask'] > 0){
			Task::where('id', '=', $task['id_originTask'])->orWhere('id_originTask', '=', $task['id_originTask'])->update(array('status' => 0));
		}else{
			Task::where('id_originTask', '=', $task['id'])->update(array('status' => 0));
		}

		return Response::json ( array (
				'success' => true
		) );

	}


}

