<?php
namespace App\Http\Controllers;

use App\Models\CustomerDevice;
use App\Models\WorkSheet;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Input;
use Illuminate\Support\Facades\Response;
use Illuminate\Routing\Controller as BaseController;
use App\Models\User;

class UsersController extends BaseController {


    public function saveUser(Request $request){

        $newUser = $request->input('newUser');
        $user = $request->input('user');
        if(isset($newUser['id']) && $newUser['id'] > 0){
            $userObj = User::find($newUser['id']);
        }else{
            $userObj = new User();
            $userObj->id_customer = $user['id'];
        }

        $forPaths = isset($newUser['forPaths'])? implode(",", $newUser['forPaths']) : '';
        $PLCRegister = isset($newUser['forPLCRegisters'])? implode(",", $newUser['forPLCRegisters']) : '';
        $workSheetRegisters = isset($newUser['forWorkSheetRegisters'])? implode(",", $newUser['forWorkSheetRegisters']) : '';

        $userObj->mail = $newUser['mail'];
        $userObj->password = $newUser['password'];
        $userObj->forHmi = $newUser['forHmi'];
        $userObj->forAlers = $newUser['forAlers'];
        $userObj->forRouters = $newUser['forRouters'];
        $userObj->forConfig = $newUser['forConfig'];
        $userObj->forUserData = $newUser['forUserData'];
        $userObj->forPLC = $newUser['forPLC'];
        $userObj->forHelp = $newUser['forHelp'];
        $userObj->forWorkSheets = $newUser['forWorkSheets'];
        $userObj->forPaths = $forPaths;
        $userObj->forPLCRegisters = $PLCRegister;
        $userObj->forWorkSheetRegisters = $workSheetRegisters;
        $userObj->status = 1;
        $userObj->save();

        return Response::json ( array (
            'success' => true,
            'tmp' =>$forPaths
        ));

    }

    public function getUsers(Request $request){

        $user = $request->input('user');

        $users = User::where('id_customer', '=', $user['id'])->where('status', '=', 1)->get();
        if(count($users) > 0)
            $users = $users->toArray();

        return Response::json ( array (
            'success' => true,
            'users' => $users
        ));
    }


    public function getUser(Request $request){

        $id_user = $request->input('id_user');

        $user = User::find($id_user);

        $paths = array();

        $devicesObj = CustomerDevice::where('id_customer', '=', $user->id_customer)->where('type', '=', '1')->with('paths')->get();
        if(count($devicesObj) > 0)
            foreach ($devicesObj as $deviceObj){
                if(count($deviceObj->paths) > 0)
                    foreach ($deviceObj->paths as $path){
                        $paths [] = array('id' => $path->id, 'label' => $deviceObj->ip . ' -> ' . $path->fileName . '(' . $path->label . ')' );
                    }
            }
        $user->forPaths = explode(',', $user->forPaths);
        $user->forPLCRegisters = explode(',', $user->forPLCRegisters);
        $user->forWorkSheetRegisters = explode(',', $user->forWorkSheetRegisters);

        $devicesPLCObj = CustomerDevice::where('id_customer', '=', $user->id_customer)->where('type', '=', '2')->get();
        $workSheetsObj = WorkSheet::where('id_customer', '=', $user->id_customer)->where('status', '=', 1)->get();

        return Response::json ( array (
            'success' => true,
            'user' => $user,
            'devicesPLCObj' => $devicesPLCObj,
            'workSheetsObj' => $workSheetsObj,
            'paths' => $paths
        ));
    }


    public function deleteUser(Request $request){

        $id_user = $request->input('id_user');

        $user = User::find($id_user);
        $user->status = 0;
        $user->save();


        return Response::json ( array (
            'success' => true
        ));
    }


}
