<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Input;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Response;
use Illuminate\Routing\Controller as BaseController;
use Exception;

use App\Models\LoadingProcess;
use App\Models\Registro;
use App\Models\CustomerDevice;


class WSController extends BaseController {
	public function receiveFiles(Request $request) {
		$registers = $request->input ( 'devices' );

		$loadingProcess = new LoadingProcess ();
		$loadingProcess->noRegistros = count ( $registers );
		$loadingProcess->status = 1;
		$loadingProcess->save ();


		// error
		$statusCode = 2;
		$data = array ();

		try {
			if (count ( $registers ) > 0) {
				foreach ( $registers as $register ) {
					$arrayRegister = explode ("|", $register );
					$arrayDate = explode("/",$arrayRegister [2]);
					$data [] = array (
							'idDispositivo' => $arrayRegister [0],
							'id_loadingProcess' => $loadingProcess->id,
							'time' => $arrayRegister [1],
							'date' => $arrayDate[2] ."-" . $arrayDate[1]."-".$arrayDate[0] ,
							'coordinates' => $arrayRegister [3] ,
							'variables' => $arrayRegister [4] ,
							'status' => 1
					);
				}

				Registro::insert ( $data );
				$statusCode = 0;
			} else {
				$statusCode = 1;
			}
		} catch ( Exception $e ) {
			$statusCode = 2;
		}

		$loadingProcess->statusTransaction = $statusCode;
		$loadingProcess->save ();

		return Response::json ( array (
				'success' => true,
				'statusCode' => $statusCode
		) );
	}


	public static function uploadFiles(Request $request){


	    Log::info("LLega a la carga de archivos: ");

	    $deviceName = $request->input("device");
	    $ipName = $request->input("ip");

	    $sampleFileUploaded = "sampleFile.csv";
	    $eventFileUploaded = "eventFile.csv";

	    Log::info("Sube el archivo al dispositivo: " . $deviceName);

	    $sampleFile = $request->file ( 'sampleFile' );
	    $up1Success = $sampleFile->move ( "devices/" . $deviceName .'/', $sampleFileUploaded );

	    if($up1Success)
	    {
	        Log::info("Se sub�o con exito el archivo: " . $deviceName);
	    }
	    else
	    {
	        echo "There was an error uploading the file <br>";
	        Log::info("Hubo un error al cargar el archivo: " . $deviceName);
	    }

	    $eventFile = $request->file ( 'eventFile' );
	    $up2Success = $eventFile->move ( "devices/" . $deviceName .'/', $eventFileUploaded );

	    if($up2Success)
	    {
	        Log::info("Se sub�o con exito el archivo eventos: " . $deviceName);
	    }
	    else
	    {
	        Log::info("Hubo un error al cargar el archivo de eventos: " . $deviceName);
	        echo "There was an error uploading the file eventFile <br>";
	    }

	    $deviceCustomer = CustomerDevice::find($deviceName);
	    $deviceCustomer->pendingProcess = 1;
	    $deviceCustomer->save();

	    Log::info("Se termina el proceso: " . $deviceName);

	    echo "serverNAme" . $deviceName;

	}
}

