<?php
namespace App\Models;
use Illuminate\Database\Eloquent\Model;

class CustomerDevice extends Model {

	protected $table = 'CustomerDevice';

	public $timestamps = false;

	protected $primaryKey = 'id';

	public function employee(){
		return $this->hasOne('App\Models\Employee', 'id', 'id_employee');
	}
	
	public function router(){
	    return $this->hasOne('App\Models\Router', 'id', 'id_router');
	}

	public function registers() {
		return $this->hasMany('App\Models\Registro', 'idDispositivo', 'idDispositivo');
	}

	public function variables() {
		return $this->hasMany('App\Models\Variables', 'id_device', 'id');
	}

	public function customer(){
	    return $this->hasOne('App\Models\Customer', 'id', 'id_customer');
	}

	public function paths() {
		return $this->hasMany('App\Models\PathGraphic', 'id_customerDevice', 'id');
	}

	public function registersplc() {
		return $this->hasMany('App\Models\PLCRegister', 'id_device', 'id');
	}

}
?>
