
(function() {
	'use strict';

	angular.module('app.forms').controller('AlertsController',
			AlertsController);

	AlertsController.$inject = [ '$scope', '$http', '$state', '$stateParams',
			'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function AlertsController($scope, $http, $state, $stateParams, Notify,
			$rootScope, SweetAlert, ngDialog) {

		var vm = this;
		vm.devices = [];
		vm.alerts = [];
		vm.paths = [];
		vm.loading = "";
		activate();

		function activate() {
			
			$rootScope.useDatePicker($.datepicker);

			$rootScope.searchAlerts.id_file = $stateParams.id;

			vm.filterAlerts = function(){
				
				vm.loading = "whirl double-up";

				$http.post('/api/admin/devices/getAlerts', {
					user : $rootScope.user,
					searchAlerts: $rootScope.searchAlerts
				}).then(function(res) {
	
					var response = res['data'];
					if (response['success']) {
						vm.alerts = response['alerts'];
						vm.loading = "";
					}
				});
			
			};

			vm.getDevices = function(){
				
				vm.loading = "whirl double-up";

				$http.post('/api/admin/devices/getDevices', {
					user : $rootScope.user
				}).then(function(res) {

					var response = res['data'];
					if (response['success']) {
						vm.devices = response['devices'];
						vm.loading = "";
					}
				});

			};

			vm.selectDevice = function(){
				for(var x = 0; x < vm.devices.length; x++){
					if(vm.devices[x].id == $rootScope.searchAlerts.id_device){
						vm.paths = vm.devices[x].paths;
					}
				}
			};
			
			
			vm.getDeviceName = function(id){
				for(var x = 0; x < vm.devices.length; x++){
					if(vm.devices[x].id == id){
						return vm.devices[x].idDispositivo;
					}
				}
			};

			vm.getFileName = function(id){
				for(let x = 0; x < vm.paths.length; x++){
					if(vm.paths[x].id == id){
						return vm.paths[x].path + '/' + vm.paths[x].fileName;
					}
				}
			};
			
			vm.getDevices();
	    }

	};

})();

