
(function() {
	'use strict';

	angular.module('app.forms').controller('AlertsSMSController',
			AlertsSMSController);

	AlertsSMSController.$inject = [ '$scope', '$http', '$state', '$stateParams',
			'Notify', '$rootScope'];
	function AlertsSMSController($scope, $http, $state, $stateParams, Notify,
			$rootScope) {

		var vm = this;
		vm.customers = [];
		vm.devices = [];
		vm.alerts = [];
		vm.paths = [];
		vm.loading = "";
		activate();

		function activate() {
			
			$rootScope.useDatePicker($.datepicker);

			$rootScope.searchAlertsSMS.id_customer = $stateParams.id;

			vm.getCustomers = function(){

				if($rootScope.user.type !== 1){
					$rootScope.searchAlertsSMS.id_customer = $rootScope.user.id;
				}

				if($rootScope.searchAlertsSMS.id_customer === undefined || $rootScope.searchAlertsSMS.id_customer === 0){

					vm.loading = 'whirl double-up';
					$http.post('/api/admin/alarms/getCustomers', {
						user : $rootScope.user,
					}).then(function(res) {
						const response = res.data;
						if (response.success) {
							vm.customers = response.customers;
							vm.loading = '';
						}
					});
				}else {
					vm.getDevices();
				}

			};

			vm.filterAlerts = function(){

				vm.loading = 'whirl double-up';
				$http.post('/api/admin/alarms/getAlerts', {
					user : $rootScope.user,
					filter: $rootScope.searchAlertsSMS
				}).then(function(res) {
					const response = res.data;
					if (response.success) {
						vm.alerts = response.alarmList;
						vm.loading = '';
					}
				});
			};

			vm.getDevices = function(){
				vm.loading = 'whirl double-up';

				$http.post('/api/admin/alarms/getDevices', {
					user : $rootScope.user,
					id_customer: $rootScope.searchAlertsSMS.id_customer,
				}).then(function(res) {
					const response = res.data;
					if (response.success) {
						vm.devices = response.devices;
						vm.loading = '';
					}
				});

			};


			vm.getCustomers();
	    }

	};

})();

