
(function() {
	'use strict';

	angular.module('app.forms').controller( 'ConfigurationsController',
			ConfigurationsController);

	ConfigurationsController.$inject = [ '$scope', '$http', '$state', '$stateParams',
			'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function ConfigurationsController($scope, $http, $state, $stateParams, Notify,
			$rootScope, SweetAlert, ngDialog) {

		var vm = this;
		vm.users = [];
		vm.loading = "";
		activate();

		function activate() {

			vm.getUsers = function(){
					
				vm.loading = "whirl double-up";
	
				$http.post('/api/admin/users/getUsers', {
					user : $rootScope.user
				}).then(function(res) {
		
					var response = res['data'];
					if (response['success']) {
						vm.users = response['users'];
						vm.loading = "";
					}
				});
			};

			vm.deleteUser = function(index, id_user){

					vm.loading = "whirl double-up";
					$http.post('/api/admin/users/deleteUser', {
						user : $rootScope.user,
						id_user: id_user
					}).then(function(res) {

						var response = res['data'];
						if (response['success']) {
							vm.loading = "";
							vm.users.splice(index, 1);
						}
					});

			};

			
			vm.getUser = function(id){
				$state.transitionTo('app.user-details', {id : id});
			};
			
			
			vm.getUsers();
	    }

	};

})();



(function() {
	'use strict';

	angular.module('app.forms').controller('UserDetailController',
			UserDetailController);

	UserDetailController.$inject = [ '$scope', '$http', '$state', '$stateParams',
			'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function UserDetailController($scope, $http, $state, $stateParams, Notify,
			$rootScope, SweetAlert, ngDialog) {

		let vm = this;
		vm.user = {
			id_customer : $rootScope.user.id,
			mail: '',
			password: '',
			status: '1',
			forHmi: "1,1,1,1",
			forAlers: "1,1",
			forRouters: "1,1,1,1",
			forConfig: "1,1,1,1",
			forUserData: "1,1,1",
			forPLC: "1,1,1",
			forHelp: "1",
			forWorkSheets: "1,1"
		};
		vm.loading = "";
		vm.devicesPLCObj = [];
		activate();

		function activate() {
			
			var id_user = $stateParams.id;

			vm.getUser = function(){
				
				if(id_user > 0){
				
					vm.loading = "whirl double-up";
	
					$http.post('/api/admin/users/getUser', {
						user : $rootScope.user,
						id_user: id_user
					}).then(function(res) {
		
						var response = res['data'];
						if (response['success']) {
							vm.user = response['user'];
							vm.paths = response.paths;
							vm.devicesPLCObj = response.devicesPLCObj;
							vm.workSheetsObj =response.workSheetsObj;
							vm.user.status += '';
							vm.checkBoxUpdate();
							vm.loading = "";
						}
					});
				}
			
			};

			
			vm.updateUser = function(){
				
				vm.loading = "whirl double-up";
				if(vm.validatePassword() == false){
					vm.loading = "";
					return;
				}
				
				if(vm.validateEmail(vm.user.mail) == false){
					vm.loading = "";
					return;
				}
									
				
				for(var x = 1; x <= 8; x++){
					switch(x){
						case 1:
							vm.user.forHmi = ($("#acc"+x).is(':checked') ? 1 : 0) + ',' + ($("#update"+x).is(':checked') ? 1 : 0) + ',' + ($("#report"+x).is(':checked') ? 1 : 0);
							break;
						case 2:
							vm.user.forAlers = ($("#acc"+x).is(':checked') ? 1 : 0) + ',' + ($("#update"+x).is(':checked') ? 1 : 0) + ',' + $("#report"+x).val();
							break;
						case 3:
							vm.user.forRouters = ($("#acc"+x).is(':checked') ? 1 : 0) + ',' + ($("#update"+x).is(':checked') ? 1 : 0) + ',' + ($("#report"+x).is(':checked') ? 1 : 0);
							break;
						case 4:
							vm.user.forConfig = ($("#acc"+x).is(':checked') ? 1 : 0) + ',' + ($("#update"+x).is(':checked') ? 1 : 0) + ',' + ($("#report"+x).is(':checked') ? 1 : 0);
							break;
						case 5:
							vm.user.forUserData = ($("#acc"+x).is(':checked') ? 1 : 0) + ',' + ($("#file"+x).is(':checked') ? 1 : 0) + ',' + ($("#img"+x).is(':checked') ? 1 : 0);
							break;
						case 6:
							vm.user.forPLC = ($("#acc"+x).is(':checked') ? 1 : 0) + ',' + ($("#update"+x).is(':checked') ? 1 : 0) + ',' + ($("#report"+x).is(':checked') ? 1 : 0);
							break;
						case 7:
							vm.user.forHelp = ($("#acc"+x).is(':checked') ? 1 : 0);
							break;
						case 8:
							vm.user.forWorkSheets = ($("#acc"+x).is(':checked') ? 1 : 0) + ',' + ($("#update"+x).is(':checked') ? 1 : 0);
							break;
					}
				}
				
				$http.post('/api/admin/users/saveUser', {
					user : $rootScope.user,
					newUser : vm.user,
				}).then(function(res) {

					vm.loading = "";

					var response = res['data'];
					if (response['success']) {
						Notify.alert('El usuario y los permisos se actualizaron de forma correcta', {status: 'success'});
					}

				});

			};
			
			vm.checkBoxUpdate = function(){
				
				let forHMI = vm.user.forHmi.split(',');
				let forAlers = vm.user.forAlers.split(',');
				let forRouters = vm.user.forRouters.split(',');
				let forConfig = vm.user.forConfig.split(',');
				let forUserData = vm.user.forUserData.split(',');
				let forPLC = vm.user.forPLC.split(',');
				let forHelp = vm.user.forHelp.split(',');
				let forWorkSheets = vm.user.forWorkSheets.split(',');

				
				if(forHMI[0] == 0){
					$("#acc1").prop('checked', false);
				}
				if(forHMI[1] == 0){
					$("#update1").prop('checked', false);
				}
				if(forHMI[2] == 0){
					$("#report1").prop('checked', false);
				}
				
				
				if(forAlers[0] == 0){
					$("#acc2").prop('checked', false);
				}
				if(forAlers[1] == 0){
					$("#update2").prop('checked', false);
				}
				if(forAlers[2] == 0){
					$("#report2").prop('checked', false);
				}
				
				
				if(forRouters[0] == 0){
					$("#acc3").prop('checked', false);
				}
				if(forRouters[1] == 0){
					$("#update3").prop('checked', false);
				}
				if(forRouters[2] == 0){
					$("#report3").prop('checked', false);
				}
				
				
				if(forConfig[0] == 0){
					$("#acc4").prop('checked', false);
				}
				if(forConfig[1] == 0){
					$("#update4").prop('checked', false);
				}
				if(forConfig[2] == 0){
					$("#report4").prop('checked', false);
				}


				if(forUserData[0] == 0){
					$("#acc5").prop('checked', false);
				}
				if(forUserData[1] == 0){
					$("#file5").prop('checked', false);
				}
				if(forUserData[2] == 0){
					$("#img5").prop('checked', false);
				}

				if(forPLC[0] == 0){
					$("#acc6").prop('checked', false);
				}
				if(forPLC[1] == 0){
					$("#update6").prop('checked', false);
				}
				if(forPLC[2] == 0){
					$("#report6").prop('checked', false);
				}

				if(forHelp[0] == 0){
					$("#acc7").prop('checked', false);
				}

				if(forWorkSheets[0] == 0){
					$("#acc8").prop('checked', false);
				}
				if(forWorkSheets[1] == 0){
					$("#update8").prop('checked', false);
				}
				
			}
			
			vm.validatePassword = function(){
				
				var paswd=  /^(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[^a-zA-Z0-9])(?!.*\s).{8,15}$/;

				if(vm.user.password.match(paswd))
				{
					$("#errorPassword").html('');
					return true;
				}
				else
				{ 
					$("#errorPassword").html('Debe contener al menos 8 caracteres, una mayúscula, una minúscula y un carácter especial.');
					return false;
				}
				
			};
			
			vm.validateEmail = function(email){
			    var emailReg = new RegExp(/^(("[\w-\s]+")|([\w-]+(?:\.[\w-]+)*)|("[\w-\s]+")([\w-]+(?:\.[\w-]+)*))(@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$)|(@\[?((25[0-5]\.|2[0-4][0-9]\.|1[0-9]{2}\.|[0-9]{1,2}\.))((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\.){2}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\]?$)/i);
			    
			    if(emailReg.test(email)) 
				{ 
					$("#errorMail").html('');
					return true;
				}
				else
				{ 
					$("#errorMail").html('El correo ingresado es inválido.');
					return false;
				}
			    
			}
			
			vm.getUser();
	    }

	};

})();




(function() {
	'use strict';

	angular.module('app.forms').controller('SubUserController',
		SubUserController);

	SubUserController.$inject = [ '$scope', '$http', '$state', '$stateParams',
		'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function SubUserController($scope, $http, $state, $stateParams, Notify,
								  $rootScope, SweetAlert, ngDialog) {

		var vm = this;
		vm.user = {
			id_customer : $rootScope.user.id,
			mail: '',
			password: '',
			status: '1',
			forHmi: "1,1,1,1",
			forAlers: "1,1,1,1",
			forRouters: "1,1,1,1",
			forConfig: "1,1,1,1",
			password2: '',
			confirmPassword: ''
		};
		vm.loading = "";
		activate();

		function activate() {

			var id_user = $stateParams.id;

			vm.getUser = function(){

					vm.loading = "whirl double-up";

					$http.post('/api/admin/users/getUser', {
						user : $rootScope.user,
						id_user: $rootScope.user.id_user
					}).then(function(res) {

						var response = res['data'];
						if (response['success']) {
							vm.user = response['user'];
							vm.user.password2 = '';
							vm.user.confirmPassword = '';
							vm.user.status += '';
							vm.loading = "";
						}
					});

			};


			vm.updateUser = function(){

				vm.loading = "whirl double-up";
				if(vm.validatePassword() == false){
					vm.loading = "";
					return;
				}

				$http.post('/api/admin/users/saveUser', {
					user : $rootScope.user,
					newUser : vm.user,
				}).then(function(res) {

					vm.loading = "";

					var response = res['data'];
					if (response['success']) {
						Notify.alert('Se actualizó la contraseña de forma correcta', {status: 'success'});
					}

				});

			};



			vm.validatePassword = function(){

				var paswd=  /^(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[^a-zA-Z0-9])(?!.*\s).{8,15}$/;

				if(vm.user.password2.match(paswd))
				{

					if(vm.user.password2 != vm.user.confirmPassword){
						$("#errorPassword").html('El password y la confirmación deben ser iguales.');
						return false;
					}

					$("#errorPassword").html('');
					vm.user.password = vm.user.password2;
					return true;
				}
				else
				{
					$("#errorPassword").html('Debe contener al menos 8 caracteres, una mayúscula, una minúscula y un carácter especial.');
					return false;
				}

			};

			vm.validateEmail = function(email){
				var emailReg = new RegExp(/^(("[\w-\s]+")|([\w-]+(?:\.[\w-]+)*)|("[\w-\s]+")([\w-]+(?:\.[\w-]+)*))(@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$)|(@\[?((25[0-5]\.|2[0-4][0-9]\.|1[0-9]{2}\.|[0-9]{1,2}\.))((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\.){2}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\]?$)/i);

				if(emailReg.test(email))
				{
					$("#errorMail").html('');
					return true;
				}
				else
				{
					$("#errorMail").html('El correo ingresado es inválido.');
					return false;
				}

			};

			vm.sendEmailSupport = function() {


				if(vm.messageToSend != '' && vm.messageToSend.length > 15){

					vm.loading = "whirl double-up";

					$http.post('/api/admin/customers/sendEmailSupport', {
						messageToSend : vm.messageToSend,
						user : $rootScope.user
					}).then(function(res) {

						vm.loading = "";

						var response = res['data'];
						if (response['success']) {

							vm.messageToSend = '';
							SweetAlert.swal({
								title : 'Mensaje enviado!',
								type : 'success',
								text : 'El mensaje ha sido enviado al equipo de soporte y pronto se pondrán en contacto con usted.'
							}, function() {
							});
						}
					});

				}else{
					$("#errorMessageToSend").html('Debe ingresar al menos 15 caractéres para enviar su mensaje.');
				}

			};

			vm.getUser();
		}

	};

})();


(function() {
	'use strict';

	angular.module('app.forms').controller('SettingsController',
		SettingsController);

	SettingsController.$inject = [ '$scope', '$http', '$state', '$stateParams',
		'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function SettingsController($scope, $http, $state, $stateParams, Notify,
							   $rootScope, SweetAlert, ngDialog) {

		var vm = this;
		vm.settings = {
			server: '',
			port: '',
			emailNotifications: ''
		};
		vm.loading = "";
		activate();

		function activate() {

			vm.getSettings = function(){

				vm.loading = "whirl double-up";

				$http.post('/api/admin/settings/getSettings', {
					user : $rootScope.user
				}).then(function(res) {

					var response = res['data'];
					if (response['success']) {
						vm.settings = response.settings;
						vm.loading = "";
					}
				});

			};


			vm.saveSettings = function(){

				vm.loading = "whirl double-up";

				$http.post('/api/admin/settings/saveSettings', {
					user : $rootScope.user,
					settings : vm.settings,
				}).then(function(res) {

					vm.loading = "";

					var response = res['data'];
					if (response['success']) {
						Notify.alert('Las configuraciones se actualizaron de forma correcta.', {status: 'success'});
					}

				});

			};

			vm.doPing = function(){

				vm.loading = "whirl double-up";

				$http.post('/api/admin/devices/doPingServer', {
					user : $rootScope.user,
					server : vm.settings.server,
				}).then(function(res) {

					vm.loading = "";

					var response = res['data'];
					if (response['success']) {
						if(response.resultPing == true){
							Notify.alert('El server respondió de forma correcta.', {status: 'success'});
						}else{
							Notify.alert('El server no ha respondido de forma correcta.', {status: 'danger'});
						}
					}

				});

			};

			vm.getSettings();


		}

	};

})();

