
(function() {
	'use strict';

	angular.module('app.forms').controller('DevicesController',
			DevicesController);

	DevicesController.$inject = [ '$scope', '$http', '$state', '$stateParams',
			'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function DevicesController($scope, $http, $state, $stateParams, Notify,
			$rootScope, SweetAlert, ngDialog) {

		var vm = this;
		vm.devices = [];
		vm.loading = "";
		activate();

		function activate() {

				vm.loading = "whirl double-up";

				$http.post('/api/admin/devices/getDevices', {
					user : $rootScope.user
				}).then(function(res) {

					var response = res['data'];
					if (response['success']) {
						vm.devices = response['devices'];
						vm.loading = "";
					}
				});

				vm.getDevice = function(id){

					$state.transitionTo('app.file-list', {
						id : id
					});

				};

				vm.getStatusOfDevice = function(lastReporteDeviceString){

					var lastReporteDevice = new Date(lastReporteDeviceString);
					var currentDate = new Date();
					var timeDiff = currentDate.getTime() - lastReporteDevice.getTime();
					var minsDiff = timeDiff / 900000;

					var isActiveDevice = 1;
					if(minsDiff > 15)
						isActiveDevice = 0;

					return isActiveDevice;
				};

				vm.doPing = function(device){

					device.loadPing = "whirl double-up";

					$http.post('/api/admin/devices/doPing', {
						ipAddress : device.ip,
						user : $rootScope.user
					}).then(function(res) {

						device.loadPing = "";
						var response = res['data'];
						if (response.success && response.pingResult) {
							Notify.alert('El dispositivo respondió de forma correcta.', {status: 'success'});
							device.conectionStatus = true;
						}else{
							Notify.alert('El dispositivo NO responde.', {status: 'warning'});
							device.conectionStatus = false;
						}
					});
				};


	    }

	};

})();


(function() {
	'use strict';

	angular.module('app.forms').controller('DeviceDetail2Controller',
			DeviceDetail2Controller);

	DeviceDetail2Controller.$inject = [ '$scope', '$http', '$state', '$stateParams',
			'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function DeviceDetail2Controller($scope, $http, $state, $stateParams, Notify,
			$rootScope, SweetAlert, ngDialog) {

		var vm = this;
		vm.device = [];
		vm.customers = [];
		vm.loading = "";
		vm.dataToPrint = [];
		vm.lastRange = "";
		vm.initRange = "";
		vm.configs = [];
		vm.counterDown = 0;
		vm.isCreatedChart = false;
		vm.serchCriteria = {
				date: '',
				date2: '',
				hour: '',
				live: false,
				noRegistros: '',
				chartType: 2
		};
		vm.reportData = {
			initDate: '',
			initTime: '00:00',
			finalDate: '',
			finalTime: '23:59'
		};
		vm.dataRanges = '';
		vm.fechaEnArchivo = {fechaInicial: '', fechaFinal: ''};
        vm.isEnabled = { 1 : 'Habilitado', 0: 'Inhabilitado'};
        vm.backupTypes = { 1 : 'Diario', 2: 'Semanal', 3: 'Dos veces al mes', 4: 'Mensual'};
        vm.dayNames = { 1 : 'Lunes', 2: 'Martes', 3: 'Miércoles', 4: 'Jueves', 5: 'Viernes', 6 : 'Sábado', 7: 'Domingo'};
		$rootScope.intevalCounter = null;
		$rootScope.intevalGetInfo = null;
		vm.charts = [];
		activate();

		function activate() {

			$rootScope.useDatePicker($.datepicker);

			var id_device = $stateParams.id;
			var id_file = $stateParams.id_file;

			var today = new Date();
			var month1 = ((today.getMonth() + 1) < 10) ? '0' + (today.getMonth() + 1) : (today.getMonth() + 1);
			var day1 = ((today.getDate()) < 10) ? '0' + (today.getDate()) : (today.getDate());
			vm.serchCriteria.date = today.getFullYear() + '-' + month1 + '-' + day1;
			vm.serchCriteria.date2 = today.getFullYear() + '-' + month1 + '-' + day1;
			vm.serchCriteria.hour = '00:00';
			vm.serchCriteria.hour2 = '01:00';
			vm.reportData.initDate = vm.serchCriteria.date;
			vm.reportData.finalDate = vm.serchCriteria.date;
			vm.serchCriteria.noRegistros = 30;

			jQuery('.datetimepicker').datetimepicker({
				i18n:{
					de:{
						months:[
							'Enero','Febrero','Marzo','Abril',
							'Mayo','Junio','Julio','Agosto',
							'Septiembre','Octubre','Noviembre','Diciembre',
						],
						dayOfWeek:[
							"Dom", "Lun", "Mar", "Mi",
							"Jue", "Vier", "Sab",
						]
					}
				},
				timepicker:true,
				format:'Y-m-d H:i:s'
			});

			vm.getDataFromDevice = function(){

				if(vm.serchCriteria.chartType == 2 && vm.serchCriteria.noRegistros == ''){
						Notify.alert('Debe ingresar el número de registros a recuperar.', {status: 'danger'});
						return;
				}

				vm.serchCriteria.detaToSearch = vm.prepareDateForServer(vm.serchCriteria.date);

				if((new Date(vm.serchCriteria.date)) > (new Date(vm.serchCriteria.date2))){
					Notify.alert('La fecha inicial no es menor a la final.', {status: 'danger'});
					return;
				}

				vm.loading = "whirl double-up";

				$http.post('/api/admin/devices/getDevice', {
					user : $rootScope.user,
					id_device: id_device,
					serchCriteria: vm.serchCriteria,
					id_file: id_file
				}).then(function(res) {

					var response = res['data'];
					if (response['success']) {
						vm.device = response['device'];
						vm.customers = response['customers'];
						vm.dataToPrint = response.dataToPrint;
						vm.dataToPrint2 = response.dataToPrint2;
						vm.labels = response.labels;
						vm.lastRange = response.lastRange;
						vm.initRange = response.initRange;
						vm.dataRanges = response.dataRanges;
						vm.varNames = response.varNames;
						vm.csrfToken = response.csrfToken;
						vm.noRegisters = response.noRegisters;
						vm.file = response.file;

						if(response.errosOnFile == true){
							Notify.alert('Hay errores en el archivo, el sistema intentó reparlos. Puede descargar el archivo completo para su análisis.', {status: 'danger'});
						}

						vm.getFileDates();

						if(response.excededRecords == false){

							if(vm.dataToPrint2.length > 0)
								setTimeout(vm.printChart, 500);

						}else{
							Notify.alert('El número de registros es mayor a 2,000 y no se puede presentar en la gráfica, elija un rango menor.', {status: 'danger'});
						}



						vm.loading = "";
					}
				});

			};

			vm.getFileDates = function(){
				$http.post('/api/admin/devices/requestDatesFile', {
					user : $rootScope.user,
					id_device: id_device,
					id_file: id_file
				}).then(function(res) {

					var response = res['data'];
					if (response['success']) {
						vm.fechaEnArchivo = response.fechaEnArchivo;
					}
				});

			};

			vm.saveData = function(){

				vm.loading = "whirl double-up";

				$http.post('/api/admin/devices/saveData', {
					user : $rootScope.user,
					device: vm.device
				}).then(function(res) {

					var response = res['data'];
					if (response['success']) {
						vm.loading = "";
						Notify.alert('Se guardaron los datos de forma correcta.', {status: 'success'});
						vm.getDataFromDevice();
					}
				});

			}

			vm.asignDevice = function(){

				ngDialog.openConfirm({
		              template: 'asignDeviceModal',
		              className: 'ngdialog-theme-default large-ngDialog',
		              data: {customers: vm.customers}
		            }).then(function (id_customer) {
		            	if(id_customer > 0){
		            		vm.asignDeviceProcess(id_customer);
		            	}else{
		            		Notify.alert('Se canceló la asignación del dispositivo.', {status: 'danger'});
		            	}

		            }, function (id_customer) {
		            	if(id_customer > 0){
		            		vm.asignDeviceProcess(id_customer);
		            	}else{
		            		Notify.alert('Se canceló la asignación del dispositivo.', {status: 'danger'});
		            	}
		            });
			}

			vm.asignDeviceProcess = function(id_customer){

				vm.loading = "whirl double-up";

				$http.post('/api/admin/devices/asignDevice', {
					user : $rootScope.user,
					id_device: id_device,
					id_customer: id_customer
				}).then(function(res) {

					var response = res['data'];
					if (response['success']) {

						Notify.alert('Dispositivo asignado correctamente.', {status: 'success'});
						vm.loading = "";
						$state.transitionTo('app.device-details2', {id: id_device}, {
							  reload: true, inherit: false, notify: true
							});
					}
				});

			};




			vm.updateCharts = function(){

				for(let x = 0; x < vm.charts.length; x++){
					for(let y = 0; y < vm.charts[x].chartTmp.config.data.datasets.length; y++){
						vm.charts[x].chartTmp.config.data.datasets[y].data = vm.dataToPrint2[x][y];
						vm.charts[x].chartTmp.update();
					}

				}

			};

			vm.printChart = function(){

				var colors = ['#0D9949', '#5B8DFF', '#52FF8F', '#E7FF47', '#FFBC3B', '#FF2E2E', '#668F2B', '#1A2236', '#84407F', '#A9FE17'];
				var rangeColos = ['#FFBABD', '#'];

				let labelCharts = [];
				if(vm.file.varsf != null)
					labelCharts = vm.file.varsf.varNames.split(',');
				Chart.defaults.global.responsive = true;


				for(let x = 0; x < vm.dataToPrint2.length; x++) {

					if(labelCharts[x] == undefined)
						labelCharts.push('');

					for (let z = 0; z < vm.dataToPrint2[x].length; z++) {
						for (let y = 0; y < vm.dataToPrint2[x][z].length; y++) {
							vm.dataToPrint2[x][z][y].t = Number(vm.dataToPrint2[x][z][y].t + '000');
						}
					}
				}


				for(let x = 0; x < vm.dataToPrint2.length; x++){

					if(vm.isCreatedChart){
						vm.updateCharts();
						return;
					}

					vm.charts.push({cfg: '', ctx: '', chartTmp: ''});

					vm.charts[x].ctx = document.getElementById('canvas' + x).getContext('2d');

					if(vm.mobileAndTabletcheck() == true)
					    vm.charts[x].ctx.canvas.height = 300;

					var color = Chart.helpers.color;

					var datasets = [];

					var dataTmpC = vm.dataToPrint2[x][0];
					datasets.push({
						label: labelCharts[x],
						backgroundColor: color(colors[x]).alpha(0.5).rgbString(),
						borderColor: colors[x],
						data: dataTmpC,
						type: 'line',
						pointRadius: 1,
						fill: false,
						lineTension: 0,
						borderWidth: 2
					});

					if(vm.dataToPrint2[x][1].length > 0)
					datasets.push({
						label: 'Límite inferior',
						backgroundColor: color(rangeColos[0]).alpha(0.5).rgbString(),
						borderColor: rangeColos[0],
						data: vm.dataToPrint2[x][1],
						type: 'line',
						pointRadius: 1,
						fill: false,
						lineTension: 0,
						borderWidth: 1
					});

					if(vm.dataToPrint2[x][2].length > 0)
					datasets.push({
						label: 'Límite superior',
						backgroundColor: color(rangeColos[0]).alpha(0.5).rgbString(),
						borderColor: rangeColos[0],
						data: vm.dataToPrint2[x][2],
						type: 'line',
						pointRadius: 1,
						fill: false,
						lineTension: 0,
						borderWidth: 1
					});


					vm.charts[x].cfg = {
						data: {
							datasets: datasets
						},
						options: {
							responsive:true,
							animation: {
								duration: 0
							},
							scales: {
								xAxes: [{
									type: 'time',
									distribution: 'series',
									offset: true,
									ticks: {
										major: {
											enabled: true,
											fontStyle: 'bold'
										},
										source: 'data',
										autoSkip: true,
										autoSkipPadding: 75,
										maxRotation: 0,
										sampleSize: 100
									},
									afterBuildTicks: function(scale, ticks) {
										var majorUnit = scale._majorUnit;
										var firstTick = ticks[0];
										var i, ilen, val, tick, currMajor, lastMajor;

										val = moment(ticks[0].value);
										if ((majorUnit === 'minute' && val.second() === 0)
											|| (majorUnit === 'hour' && val.minute() === 0)
											|| (majorUnit === 'day' && val.hour() === 9)
											|| (majorUnit === 'month' && val.date() <= 3 && val.isoWeekday() === 1)
											|| (majorUnit === 'year' && val.month() === 0)) {
											firstTick.major = true;
										} else {
											firstTick.major = false;
										}
										lastMajor = val.get(majorUnit);

										for (i = 1, ilen = ticks.length; i < ilen; i++) {
											tick = ticks[i];
											val = moment(tick.value);
											currMajor = val.get(majorUnit);
											tick.major = currMajor !== lastMajor;
											lastMajor = currMajor;
										}
										return ticks;
									}
								}],
								yAxes: [{
									gridLines: {
										drawBorder: false
									},
									scaleLabel: {
										display: true,
										labelString: labelCharts[x]
									}
								}]
							},
							tooltips: {
								intersect: false,
								mode: 'index',
								callbacks: {
									label: function(tooltipItem, myData) {
										var label = myData.datasets[tooltipItem.datasetIndex].label || '';
										if (label) {
											label += ': ';
										}
										label += parseFloat(tooltipItem.value).toFixed(2);
										return label;
									}
								}
							}
						}
					};

					let chartTmp = new Chart(vm.charts[x].ctx, vm.charts[x].cfg);

					vm.charts[x].chartTmp = chartTmp;

				}

				if(vm.charts.length > 0)
				    vm.isCreatedChart = true;

			};




            vm.mobileAndTabletcheck = function() {
                var check = false;
                (function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino|android|ipad|playbook|silk/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))) check = true;})(navigator.userAgent||navigator.vendor||window.opera);
                return check;
            };

			vm.setDeviceOnline = function(){

				if(vm.serchCriteria.live == true){

					vm.counterDown = 60;
					$rootScope.intevalCounter = setInterval(function(){ vm.downCounter(); }, 1000);

					today = new Date();
					month1 = ((today.getMonth() + 1) < 10) ? '0' + (today.getMonth() + 1) : (today.getMonth() + 1);
					day1 = ((today.getDate()) < 10) ? '0' + (today.getDate()) : (today.getDate());
					vm.serchCriteria.date = today.getFullYear() + '-' + month1 + '-' + day1;
					vm.serchCriteria.hour = (today.getHours() < 10) ? '0' + today.getHours() : today.getHours();
					vm.serchCriteria.hour += ':00';

					$http.post('/api/admin/devices/setCustomerDeviceOnline', {
		                user: $rootScope.user,
		                isOnline: 1,
		                id_device: id_device
		            }).then(function (res) {
		            });
				}

			};

			vm.changeChartType = function(newChartType){
				vm.serchCriteria.chartType = newChartType;
				vm.getDataFromDevice();
			};

			vm.createReport = function(){
				ngDialog.openConfirm({
		              template: 'createReportModal',
		              className: 'ngdialog-theme-default large-ngDialog',
		              data: {reportData: vm.reportData, ip: vm.device.ip, id_file: vm.file.id, fileName: vm.file.fileName},
									controller: 'ReportDataController',
		            }).then(function (createReport) {

		            }, function (createReport) {
		            	if(createReport > 0){
		            		$("#initDate").val(vm.reportData.initDate);
		            		$("#initTime").val(vm.reportData.initTime);
		            		$("#finalDate").val(vm.reportData.finalDate);
		            		$("#finalTime").val(vm.reportData.finalTime);
		            		$("#id_device").val(id_device);
							$("#id_file").val(vm.file.id);
		            		$("#downloadExcel").submit();
		            	}
		            });
			};

			vm.configDevice = function(){

				console.log("Sergio file", vm.file)

				ngDialog.openConfirm({
		              template: 'configDeviceModal',
		              className: 'ngdialog-theme-default large-ngDialog',
		              data: {file: vm.file},
					  controller: 'ConfigDeviceController',
		            }).then(function (createReport) {
		            }, function (process) {
		            	if(process === 1){
		            		vm.getDataFromDevice();
		            	}else if(process.periodicity !== undefined){
							vm.file.activateBackups = process.activateBackups ? 1: 0;
							vm.file.periodicity = process.periodicity;
							vm.file.value = process.value;
							vm.file.time = process.time;
						}
		            });

			};

			function receiveDataDevice(){
				if(vm.serchCriteria.live == true){
					vm.counterDown = 60;
					today = new Date();
					month1 = ((today.getMonth() + 1) < 10) ? '0' + (today.getMonth() + 1) : (today.getMonth() + 1);
					day1 = ((today.getDate()) < 10) ? '0' + (today.getDate()) : (today.getDate());
					vm.serchCriteria.date = today.getFullYear() + '-' + month1 + '-' + day1;
					vm.serchCriteria.hour = (today.getHours() < 10) ? '0' + today.getHours() : today.getHours();
					vm.serchCriteria.hour += ':00';

					vm.getDataFromDevice();
				}
			};

			vm.prepareDateForServer = function(dateObj){

				if(dateObj instanceof Date){

					var day = (dateObj.getDate() < 10)? '0' + dateObj.getDate() : dateObj.getDate();
					var month = (dateObj.getMonth() < 9) ? '0' + (dateObj.getMonth() + 1) : (dateObj.getMonth() + 1);
					var year = dateObj.getFullYear();
					var hours = (dateObj.getHours() < 10) ? '0' + dateObj.getHours() : dateObj.getHours();
					var minutes = (dateObj.getMinutes() < 10) ? '0' + dateObj.getMinutes() : dateObj.getMinutes();;

					dateObj = year + '-' + month + '-' + day + ' ' + hours + ':' + minutes + ':00';

				}

				return dateObj;

			};

			vm.downCounter = function(){
				vm.counterDown--;
				document.getElementById('counterDown').innerHTML = vm.counterDown;
			};

			vm.requestDowloadFile = function(){

				vm.loading = "whirl double-up";

				$http.post('/api/admin/devices/requestDownloadFile', {
					user : $rootScope.user,
					id_device: vm.device.id,
					id_file: id_file
				}).then(function(res) {

					vm.loading = "";

					var response = res['data'];
					if (response['success']) {

						if(response.isConnected == false){
							if(response.errorCode == 1002){
								Notify.alert('No se ha podido encontrar el directorio.', {status: 'danger'});
							}else if(response.errorCode == 1003){
								Notify.alert('No se ha podido encontrar el archivo.', {status: 'danger'});
							}else if(response.errorCode == 1004){
								Notify.alert('El parámetro de separador de datos se configuró de forma incorrecta.', {status: 'danger'});
							}else if(response.errorCode == 1005){
								Notify.alert('El orden o el formato de Fecha/hora se configuró de forma incorrecta.', {status: 'danger'});
							}else if(response.errorCode == 1006){
								Notify.alert('No se ha podido encontrar el archivo.', {status: 'danger'});
							}else if(response.errorCode == 1021){
								Notify.alert('El endpoint no se encuentra disponible.', {status: 'danger'});
							}else{
								Notify.alert('No se ha podido contacar al dispositivo.', {status: 'danger'});
							}
						}else{

							vm.getFileDates();

							Notify.alert('Se descargó el archivo de forma correcta.', {status: 'success'});
							vm.fechaEnArchivo = response.fechasArchivo;
							vm.file.lastUpdate = response.lastUpdate;
						}

					}else{
						Notify.alert('No se ha podido contacar al dispositivo.', {status: 'danger'});
					}
				}, function errorCallback(response) {
					vm.loading = "";
					Notify.alert('No se ha podido contacar al dispositivo.', {status: 'danger'});
				});

			};

			vm.doPing = function(device){

				vm.loadingPing = "whirl double-up";
				$http.post('/api/admin/devices/doPing', {
					ipAddress : device.ip,
					user : $rootScope.user
				}).then(function(res) {
					vm.loadingPing = "";
					var response = res['data'];
					if (response.success && response.pingResult) {
						Notify.alert('El dispositivo respondió de forma correcta.', {status: 'success'});
					}else{
						Notify.alert('El dispositivo NO responde.', {status: 'warning'});
					}
				});
			};

			vm.verifyFile = function(){

				vm.loadingVerify = "whirl double-up";
				$http.post('/api/admin/devices/verifyFile', {
					id_device : id_device,
					id_file: id_file,
					user : $rootScope.user
				}).then(function(res) {
					vm.loadingVerify = "";
					var response = res['data'];
					if (response.success && response.fileExist) {
						Notify.alert('El se encontró de forma correcta.', {status: 'success'});
					}else{
						Notify.alert('El archivo NO pudo ser localizado.', {status: 'warning'});
					}
				});
			};

            vm.getPeriodicityValue = function(){

                if(vm.file.periodicity == 1){
                    return '';
                } else if(vm.file.periodicity == 2){
                    return ' los días ' + vm.dayNames[vm.file.value];
                } else if(vm.file.periodicity == 3){
                    return ' los días ' + vm.file.value + ' y ' + (Number(vm.file.value) +15);
                } else if(vm.file.periodicity == 4){
                    return ' los días ' + vm.file.value;
                }

            };

			vm.getDataFromDevice();

	};

};

})();


(function() {
	'use strict';

	angular.module('app.forms').controller('ReportDataController',
			ReportDataController);

	ReportDataController.$inject = [ '$scope', '$http', '$state', '$stateParams',
			'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function ReportDataController($scope, $http, $state, $stateParams, Notify,
			$rootScope, SweetAlert, ngDialog) {



		setTimeout(function(){ $rootScope.useDatePicker($.datepicker); $("#tmpInitTime").focus();}, 50);



	};

})();



(function() {
	'use strict';

	angular.module('app.forms').controller('ConfigDeviceController',
			ConfigDeviceController);

	ConfigDeviceController.$inject = [ '$scope', '$http', '$state', '$stateParams',
			'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function ConfigDeviceController($scope, $http, $state, $stateParams, Notify,
			$rootScope, SweetAlert, ngDialog) {

		$scope.loading = "";

		$scope.backups = {
			activateBackups: false,
			periodicity: '',
			value: '',
			id_file: $scope.ngDialogData.file.id,
			time: '00:00',
			lastSuccessfulBackup: $scope.ngDialogData.file.lastSuccessfulBackup
		}

		if($scope.ngDialogData.file.activateBackups !== null){
			$scope.backups.activateBackups = $scope.ngDialogData.file.activateBackups === 1 ? true : false;
		}

		if($scope.ngDialogData.file.periodicity !== null){

			if($scope.ngDialogData.file.time.length === 8){
				$scope.ngDialogData.file.time = $scope.ngDialogData.file.time.substring(0,5)
			}

			$scope.backups.periodicity = $scope.ngDialogData.file.periodicity;
			$scope.backups.value = $scope.ngDialogData.file.value + '';
			$scope.backups.time = $scope.ngDialogData.file.time;
		}

		$scope.ngDialogData.file.startLine += '';
		$scope.ngDialogData.file.columns += '';
		$scope.ngDialogData.file.separatorr += '';

		if($scope.ngDialogData.file.varsf == null){
			$scope.ngDialogData.file.varsf = {
				varNames: '',
				varRanges: '0-0'
			};
		}


		if($scope.ngDialogData.file.varsf.varRanges == ''){
			$scope.ngDialogData.file.varsf.varRanges = '0-0';
		}
		var varNames = angular.copy($scope.ngDialogData.file.varsf.varNames.split(','));
		var ranges = angular.copy($scope.ngDialogData.file.varsf.varRanges.split(','));

		$scope.printElements = function(){
			var html = '';
			for(var x = 0; x < varNames.length; x++){
				var rangesSplit = ranges[x].split('-');
				html += "<tr><td>"+(x+1)+"</td><td><input type='text' id='channelName"+x+"' class='form-control input-sm' value='"+varNames[x]+"' /></td><td><input type='text' class='form-control input-sm' id='min"+x+"' value='"+rangesSplit[0]+"' /></td><td><input type='text' class='form-control input-sm' id='max"+x+"' value='"+rangesSplit[1]+"' /></td></tr>";
			}
			$("#configHTML").html(html);
		};

		$scope.addElement =function(){

			for(var x = 0; x < varNames.length; x++){
				varNames[x] = $("#channelName"+x).val();
				ranges[x] = $("#min"+x).val() + '-' + $("#max"+x).val();
			}

			varNames.push('');
			ranges.push('0-0');
			$scope.printElements();
		};

		$scope.saveVarData = function(){

			$scope.loading = "whirl double-up";

			var varNameUpdate = '';
			var varRangesUpdate = '';
			for(var x = 0; x < varNames.length; x++){
				varNameUpdate += $("#channelName"+x).val();
				varRangesUpdate += $("#min"+x).val() + '-' + $("#max"+x).val();

				if(x < (varNames.length-1)){
					varNameUpdate += ',';
					varRangesUpdate += ',';
				}
			}


			$http.post('/api/admin/devices/saveVarData', {
				user : $rootScope.user,
				id_file: $scope.ngDialogData.file.id,
				varNameUpdate: varNameUpdate,
				varRangesUpdate: varRangesUpdate,
			}).then(function(res) {

				var response = res['data'];
				if (response['success']) {
					$scope.loading = "";
					Notify.alert('Datos actualizados de forma correcta.', {status: 'success'});
					$scope.ngDialogData.file.varsf.varNames = varNameUpdate;
					$scope.ngDialogData.file.varsf.varRanges = varRangesUpdate;
					$scope.closeThisDialog(1);
				}
			});
		};

		$scope.saveActivateBackupConfig = function(){

			$scope.loading = "whirl double-up";

			$http.post('/api/admin/devices/saveActivateBackupConfig', {
				user : $rootScope.user,
				backupConfig: $scope.backups,
			}).then(function(res) {

				var response = res['data'];
				if (response['success']) {
					$scope.loading = "";
                    $scope.ngDialogData.file.activateBackups = $scope.backups.activateBackups ? 1 : 0;
				}
			});
		};

		$scope.saveBackupsConfig = function(){

			if($scope.backups.periodicity.length === 0){
				Notify.alert('Debe elegir una periodicidad.', {status: 'danger'});
				return;
			}

			if($scope.backups.value.length === 0){
				Notify.alert('Debe elegir el momento a ejecutar el respaldo.', {status: 'danger'});
				return;
			}

			$scope.loading = "whirl double-up";

			$http.post('/api/admin/devices/saveBackupsConfig', {
				user : $rootScope.user,
				backupConfig: $scope.backups,
			}).then(function(res) {

				var response = res['data'];
				if (response['success']) {
					$scope.loading = "";
					Notify.alert('Datos actualizados de forma correcta.', {status: 'success'});
					$scope.closeThisDialog($scope.backups);
				}
			});
		};

		$scope.saveFileConfig = function(){

			$scope.loading = "whirl double-up";

			$http.post('/api/admin/devices/saveFileConfig', {
				user : $rootScope.user,
				file: $scope.ngDialogData.file
			}).then(function(res) {

				var response = res['data'];
				if (response['success']) {
					$scope.loading = "";
					Notify.alert('Datos actualizados de forma correcta.', {status: 'success'});
					$scope.closeThisDialog(1);
				}
			});
		};

		setTimeout($scope.printElements, 500);

	};

})();
