
(function() {
	'use strict';

	angular.module('app.forms').controller('DevicesCustomerController',
			DevicesCustomerController);

	DevicesCustomerController.$inject = [ '$scope', '$http', '$state', '$stateParams',
			'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function DevicesCustomerController($scope, $http, $state, $stateParams, Notify,
			$rootScope, SweetAlert, ngDialog) {

		var vm = this;
		vm.devices = [];
		vm.loading = "";
		activate();

		function activate() {

			vm.loading = "whirl double-up";

			$http.post('/api/admin/devices/getDevices', {
				user : $rootScope.user
			}).then(function(res) {

				var response = res['data'];
				if (response['success']) {
					vm.devices = response['devices'];
					vm.loading = "";
				}
			});

			vm.getDevice = function(id){
				$state.transitionTo('app.file-list', {
					id : id
				});
			};

			vm.getStatusOfDevice = function(lastReporteDeviceString){

				var lastReporteDevice = new Date(lastReporteDeviceString);
				var currentDate = new Date();
				var timeDiff = currentDate.getTime() - lastReporteDevice.getTime();
				var minsDiff = timeDiff / 900000;

				var isActiveDevice = 1;
				if(minsDiff > 15)
					isActiveDevice = 0;

				return isActiveDevice;
			};

			vm.doPing = function(device){

				device.loadPing = "whirl double-up";

				$http.post('/api/admin/devices/doPing', {
					ipAddress : device.ip,
					user : $rootScope.user
				}).then(function(res) {

					device.loadPing = "";
					var response = res['data'];
					if (response.success && response.pingResult) {
						Notify.alert('El dispositivo respondió de forma correcta.', {status: 'success'});
						device.conectionStatus = true;
					}else{
						Notify.alert('El dispositivo NO responde.', {status: 'warning'});
						device.conectionStatus = false;
					}
				});
			};


	    }

	};

})();


(function() {
	'use strict';

	angular.module('app.forms').controller('FileListController',
		FileListController);

	FileListController.$inject = [ '$scope', '$http', '$state', '$stateParams',
		'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function FileListController($scope, $http, $state, $stateParams, Notify,
									   $rootScope, SweetAlert, ngDialog) {

		var vm = this;
		vm.filesList = [];
		vm.loading = "";
		activate();

		function activate() {

			vm.loading = "whirl double-up";

			var id_device = $stateParams.id;

			$http.post('/api/admin/devices/getFileList', {
				user : $rootScope.user,
				id_device: id_device
			}).then(function(res) {

				var response = res['data'];
				if (response['success']) {
					vm.filesList = response['filesList'];
					vm.loading = "";
				}
			});

			vm.getFile = function(id){

				$state.transitionTo('app.device-details2', {
					id_file : id,
					id: id_device
				});

			}

		}

	};

})();
