
(function() {
	'use strict';

	angular.module('app.forms').controller('MyProfileController',
			MyProfileController);

	MyProfileController.$inject = [ '$scope', '$http', '$state', '$stateParams',
			'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function MyProfileController($scope, $http, $state, $stateParams, Notify,
			$rootScope, SweetAlert, ngDialog) {


				var vm = this;
				vm.routes = [];
				vm.dataPayment = {
					comment : ''
				};
				vm.stores = {};
				vm.loadingPayment = "";
				vm.loadingDeleteSpecial = "";
				vm.idDispositivo = "";
				vm.messageToSend = '';
				vm.specialProduct = {};
				vm.customer = {
					contacts : [],
					taxdata :{
						city:'',
						country: 'México'

					}
				};
				vm.loading = "whirl double-up";

				activate();

				function activate() {

						$http.post('/api/admin/customers/getCustomer', {
							id_customer : $rootScope.user.id,
							user : $rootScope.user
						}).then(function(res) {
							var response = res['data'];
							if (response['success']) {
								vm.customer = response['customer'];
								vm.csrf = response.csrf;
								vm.customer.timezone += '';

								if(vm.customer.expirationDate == '0000-00-00'){
									vm.customer.expirationDate = 'Sin licencia asignada';
								}
							}

							vm.loading = "";
						});

					vm.save = function() {

							if(vm.customerForm.$valid) {

								vm.loading = "whirl double-up";

							$http.post('/api/admin/customers/saveCustomer', {
								customer : vm.customer,
								user : $rootScope.user
							}).then(function(res) {

								vm.loading = "";

								var response = res['data'];
								if (response['success']) {
									SweetAlert.swal({
										title : 'Cliente guardado!',
										type : 'success',
										text : 'El cliente se guardó con éxito!'
									}, function() {
										$state.transitionTo('app.customers');
									});
								}
							});
						}

					};
					
					vm.sendEmailSupport = function() {


						if(vm.messageToSend != '' && vm.messageToSend.length > 15){
							
							vm.loading = "whirl double-up";

							$http.post('/api/admin/customers/sendEmailSupport', {
								messageToSend : vm.messageToSend,
								user : $rootScope.user
							}).then(function(res) {
	
								vm.loading = "";
	
								var response = res['data'];
								if (response['success']) {
									
									vm.messageToSend = '';
									SweetAlert.swal({
										title : 'Mensaje enviado!',
										type : 'success',
										text : 'El mensaje ha sido enviado al equipo de soporte y pronto se pondrán en contacto con usted.'
									}, function() {
									});
								}
							});
						
						}else{
							$("#errorMessageToSend").html('Debe ingresar al menos 15 caractéres para enviar su mensaje.');
						}

				};


					vm.saveTimeZone = function () {


						vm.loading = "whirl double-up";

						$http.post('/api/admin/customers/saveCustomer', {
							customer : vm.customer,
							user : $rootScope.user
						}).then(function(res) {

							vm.loading = "";

							var response = res['data'];
							if (response['success']) {
								SweetAlert.swal({
									title : 'Listo!',
									type : 'success',
									text : 'La zona horaria se guardó con éxito!'
								}, function() {
								});
							}
						});

					};

					vm.addContact = function(){

						var newContact = {
							name: '',
							phone: '',
							position: ''
						};

						vm.customer.contacts.push(newContact);

					};
					
					vm.changeNotifications = function(){
						
						$http.post('/api/admin/customers/activateNotifications', {
							notifications : vm.customer.notifications,
							user : $rootScope.user
						}).then(function(res) {

							vm.loading = "";
							var response = res['data'];
							if (response['success']) {
								Notify.alert('Se actualizó la configuración de las notificaciones de forma exitosa.', {status: 'success'});
							}
						});
						
					};
					
					vm.uploadImage = function(){
						
						var file_data = $('#logoImage').prop('files')[0];   

						if($rootScope.validateExtention(file_data)){
						
							vm.loading = "whirl double-up";
							
						    var form_data = new FormData();                  
						    form_data.append('file', file_data);
						    form_data.append('id_customer', $rootScope.user.id);
							form_data.append("_token", vm.csrf);
						    console.log(form_data);                             
						    $.ajax({
						        url: '/api/admin/customers/uploadImageCustomer', // point to server-side PHP script 
						        dataType: 'json',  // what to expect back from the PHP script, if anything
						        cache: false,
						        contentType: false,
						        processData: false,
						        data: form_data,                         
						        type: 'post',
								headers: {
									'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
								},
						        success: function(response){
						        	vm.loading = "";
						        	
						        	if(response.success == true && response.isExito == true){
						        		Notify.alert('Se actualizó la imagen de forma exitosa.', {status: 'success'});
						        		$rootScope.user.logo = response.fileName;
						        		$state.transitionTo('app.myprofile', {}, {reload: true, inherit: false, notify: true});
						        	}else{
						        		Notify.alert('Hubo un error al cargar la imágen.', {status: 'danger'});
						        	}
						        }
						     });
						}
					};




					vm.uploadImageHome = function(){

						var file_data = $('#homeImg').prop('files')[0];

						if($rootScope.validateExtention(file_data)){

							vm.loading = "whirl double-up";

							var form_data = new FormData();
							form_data.append('file', file_data);
							form_data.append('id_customer', $rootScope.user.id);
							form_data.append("_token", vm.csrf);
							console.log(form_data);
							$.ajax({
								url: '/api/admin/customers/uploadImageHome', // point to server-side PHP script
								dataType: 'json',  // what to expect back from the PHP script, if anything
								cache: false,
								contentType: false,
								processData: false,
								data: form_data,
								type: 'post',
								headers: {
									'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
								},
								success: function(response){
									vm.loading = "";

									if(response.success == true && response.isExito == true){
										Notify.alert('Se actualizó la imagen de forma exitosa.', {status: 'success'});
										$rootScope.user.homeImg = response.fileName;
										$state.transitionTo('app.myprofile', {}, {reload: true, inherit: false, notify: true});
									}else{
										Notify.alert('Hubo un error al cargar la imágen.', {status: 'danger'});
									}
								}
							});
						}
					};


				}





	};

})();
