var idCustomer;
(function() {
	'use strict';

	angular.module('app.forms').controller('RoutersController',
			RoutersController);

	RoutersController.$inject = [ '$scope', '$http', '$state', '$stateParams',
			'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function RoutersController($scope, $http, $state, $stateParams, Notify,
			$rootScope, SweetAlert, ngDialog) {

		var vm = this;
		vm.routers = [];
		vm.customers = [];
		vm.id_customer = '0';
		vm.loading = "";
		activate();

		function activate() {

			var id_customer = $stateParams.id;

			if($rootScope.user.type == 2) {
				vm.id_customer = $rootScope.user.id;

			}else if($rootScope.user.type == 3) {
				vm.id_customer = $rootScope.user.id;
			}else
			if($rootScope.id_customerRouters > 0)
				vm.id_customer = $rootScope.id_customerRouters;

			vm.getRouters = function(){

				if(vm.id_customer > 0){
					idCustomer = vm.id_customer;
					$rootScope.id_customerRouters = vm.id_customer;
				
					vm.loading = "whirl double-up";
	
					$http.post('/api/admin/routers/getRoutersByCustomer', {
						user : $rootScope.user,
						id_customer: vm.id_customer
					}).then(function(res) {
		
						var response = res['data'];
						if (response['success']) {
							vm.routers = response['routers'];
							vm.loading = "";
						}
					});
				
				}
			
			};

			vm.addRouter = function(){
				ngDialog.openConfirm({
					template: 'addRouterModal',
					className: 'ngdialog-theme-default large-ngDialog',
					controller: 'AddRouterController',
					data: {id_customer: id_customer}
				}).then(function (router) {
					if(router.id > 0){
						vm.routers.push(router);
					}

				}, function (router) {
					if(router.id > 0){
						vm.routers.push(router);
					}
				});

			};


			vm.getCustomers = function(){
				
				vm.loading = "whirl double-up";

				$http.post('/api/admin/customers/getCustomers', {
					user : $rootScope.user
				}).then(function(res) {

					var response = res['data'];
					if (response['success']) {
						vm.loading = "";
						vm.customers = response['customers'];
					}

				});
			};
			
			vm.getRouter = function(id){
				$state.transitionTo('app.router-detail', {id : id});
			};

			vm.getRoutersOnline = function(){
				
				if(vm.id_customer > 0){
					
					$rootScope.id_customerRouters = vm.id_customer;
				
					$http.post('/api/admin/routers/getRoutersByCustomer', {
						user : $rootScope.user,
						id_customer: vm.id_customer
					}).then(function(res) {
		
						var response = res['data'];
						if (response['success']) {
							for(var x = 0; x < response['routers'].length; x++){
								vm.routers[x].isReachable = response['routers'][x].isReachable;
							}
						}
					});
				
				}
			
			};
			
			$rootScope.intervalRouter = setInterval(vm.getRoutersOnline, 60000);
			
			vm.getCustomers();
			vm.getRouters();
	    }

	};

})();

(function() {
	'use strict';

	angular.module('app.forms').controller('AddRouterController',
		AddRouterController);

	AddRouterController.$inject = [ '$scope', '$http', '$state',
		'$stateParams', 'SweetAlert', 'Notify', '$rootScope', 'ngDialog' ];
	function AddRouterController($scope, $http, $state, $stateParams,
								 SweetAlert, Notify, $rootScope, ngDialog ) {

		$scope.router = {
			name: '',
			minIp: '',
			maxIp: '',
			id_customer: idCustomer
		};

		$scope.addRouter = function(){

			if($scope.router.name.length == 0){
				Notify.alert('Debe ingresar el nombre del dispositivo', {status: 'danger'});
				return;
			}

			$scope.loading = "whirl double-up";

			$http.post('/api/admin/routers/saveRouter', {
				router : $scope.router,
				user : $rootScope.user
			}).then(function(res) {

				var response = res['data'];
				if (response['success']) {
					$scope.closeThisDialog(response.router);

					SweetAlert.swal({
						title : 'Router guardado!',
						type : 'success',
						text : 'El router se guardó con éxito!'
					}, function() {
					});
				}

			});

		};

		$scope.loading = "";

	};

})();

var router;

(function() {
	'use strict';

	angular.module('app.forms').controller('RouterDetailController',
			RouterDetailController);

	RouterDetailController.$inject = [ '$scope', '$http', '$state', '$stateParams',
			'Notify', '$rootScope', 'SweetAlert', 'ngDialog' ];
	function RouterDetailController($scope, $http, $state, $stateParams, Notify,
			$rootScope, SweetAlert, ngDialog) {

		var vm = this;
		vm.router = {};
		vm.customers = [];
		vm.id_customer = '0';
		vm.loading = "";
		vm.deviceTypes = [];
		activate();

		function activate() {
			
			var id_router = $stateParams.id;
			

			vm.getRouters = function(){
				
				vm.loading = "whirl double-up";

				$http.post('/api/admin/routers/getRouteSito', {
					user : $rootScope.user,
					id_router: id_router
				}).then(function(res) {
	
					var response = res['data'];
					if (response['success']) {
						router = response['router'];
						vm.router = response['router'];
						vm.deviceTypes = response['deviceTypes'];
						vm.loading = "";
					}
				});
			
			};
			
			
			vm.updateRouter = function(router){
				if(router.minIp == 0){
					Notify.alert('Debe ingresar la IP del dispositivo', {status: 'danger'});
					return;
				}
				let isValid = /^((\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.){3}(\d{1,2}|1\d\d|2[0-4]\d|25[0-4])$/;
				if (!isValid.test(router.minIp)) {
					Notify.alert('IP inválido', {status: 'danger'});
					return;
				}

				vm.loading = "whirl double-up";

				$http.post('/api/admin/routers/updateRouter', {
					user : $rootScope.user,
					router : router
				}).then(function(res) {

					vm.loading = "";

					var response = res['data'];
					if (response['success']) {
						Notify.alert('El router se actualizó de forma correcta', {status: 'success'});
						
					}

				});

			};

			vm.removeRouter = function(id, index){

				vm.loading = "whirl double-up";

				$http.post('/api/admin/customers/removeRouter', {
					id_router : id,
				}).then(function(res) {

					vm.loading = "";
					var response = res.data;
					if (response.success == true) {
						Notify.alert('El router se eliminó de forma correcta', {status: 'success'});
						$state.transitionTo('app.routers');
					}

				});

			};

			vm.updateDevice = function(device, route, index){
				ngDialog.openConfirm({
					template: 'modifyDeviceDetail',
					className: 'ngdialog-theme-default large-ngDialog',
					controller: 'UpdateDeviceController2',
					data: {device: device, deviceTypes: vm.deviceTypes,  id_route: route.id, id_customer: router.id_customer}
				}).then(function (device) {
				}, function (device) {
					if(device.id > 0){
						console.log(vm.router.devices)
						if(device.isNew == true){
							vm.router.devices.push(device);
						}else{
							vm.router.devices[index] = device;
						}
						console.log(vm.router.devices)
					}
				});

			};
			
			vm.getDeviceType = function(type){
				for(var x = 0; x < vm.deviceTypes.length; x++){
					if(type == x){
						return vm.deviceTypes[x];
					}
				}
				
			};
			vm.uploadVPNFile = function(){


				var file_data = $('#vpnFile').prop('files')[0];

				if(file_data != undefined) {


					vm.loading = "whirl double-up";

					var form_data = new FormData();
					form_data.append('file', file_data);
					form_data.append('id_customer', id_customer);
					form_data.append('_token', vm.csrf);
					console.log(form_data);
					$.ajax({
						url: '/api/admin/customers/uploadFileVPNCustomer', // point to server-side PHP script
						dataType: 'json',  // what to expect back from the PHP script, if anything
						cache: false,
						contentType: false,
						processData: false,
						data: form_data,
						type: 'post',
						success: function (response) {
							vm.loading = "";

							if (response.success == true && response.isExito == true) {
								vm.customer.files.push(response.file);
								Notify.alert('Se cargó el archivo de forma exitosa.', {status: 'success'});
								$state.transitionTo('app.customer-details', {id: id_customer}, {
									reload: true,
									inherit: false,
									notify: true
								});
							} else {
								Notify.alert('Hubo un error al cargar el archivo.', {status: 'danger'});
							}
						}
					});
				}else{
					Notify.alert('Debe seleccionar un archivo.', {status: 'danger'});
				}
			};

			vm.deleteFile = function(id_file, index){

				vm.loadingFiles = "whirl double-up";

				$http.post('/api/admin/customers/deleteFile', {
					user : $rootScope.user,
					id_file : id_file
				}).then(function(res) {

					vm.loadingFiles = "";

					var response = res['data'];
					if (response['success']) {
						vm.customer.files.splice(index, 1);
						Notify.alert('El se eliminó de forma correcta', {status: 'success'});
					}
				});
			};

			vm.getUser = function(id){
				$state.transitionTo('app.user-details', {id : id});
			};
			
			vm.getRoutersOnline = function(){

				$http.post('/api/admin/routers/getRouteSito', {
					user : $rootScope.user,
					id_router: id_router
				}).then(function(res) {
	
					var response = res['data'];
					if (response['success']) {
						for(var x = 0; x < response['router'].devices.length; x++){
							vm.router.devices[y].isReachable = response['router'].devices[y].isReachable;
						}
					}
				});
			
			};
			
			$rootScope.intervalDevices = setInterval(vm.getRoutersOnline, 60000);
			
			vm.getRouters();
	    }

	};


})();


(function() {
	'use strict';

	angular.module('app.forms').controller('UpdateDeviceController2',
		UpdateDeviceController2);

	UpdateDeviceController2.$inject = [ '$scope', '$http', '$state',
		'$stateParams', 'SweetAlert', 'Notify', '$rootScope', 'ngDialog' ];
	function UpdateDeviceController2($scope, $http, $state, $stateParams,
									SweetAlert, Notify, $rootScope, ngDialog ) {

		$scope.device = angular.copy($scope.ngDialogData.device);

		if($scope.device == null){
			$scope.device = {
				idDispositivo: '',
				ip: '',
				type: '0',
				user: '',
				password: '',
				label: '',
				id_customer: $scope.ngDialogData.id_customer,
				id_router: router.id,
				//id_router: $scope.ngDialogData.id_route,

			};
		};

		$scope.device.type += '';
		$scope.device.columns += '';
		$scope.device.separatorr += '';
		$scope.device.startLine += '';
		$scope.device.connectionType += '';

		$scope.deviceTypes = $scope.ngDialogData.deviceTypes;
		$scope.newPath = {path: '', fileName: '', startLine: '', columns: '', separatorr: '',
			formatDate: '', formatTime: '', encoding: ''};

		$scope.updateDevice = function(){
			console.log($scope.device);

			if($scope.device.idDispositivo.length == 0){
				Notify.alert('Debe ingresar el nombre del dispositivo', {status: 'danger'});
				return;
			}
			if($scope.device.ip.length == 0){
				Notify.alert('Debe ingresar la IP del dispositivo', {status: 'danger'});
				return;
			}

			let isValid = /^((\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.){3}(\d{1,2}|1\d\d|2[0-4]\d|25[0-4])$/;
			if (!isValid.test($scope.device.ip)) {
				Notify.alert('IP inválido', {status: 'danger'});
				return;
			}


			let ipValid = $scope.device.ip.split('.');
			let ipRouter = router.minIp.split('.');

			if(ipValid[0]+ipValid[1]+ipValid[2] != ipRouter[0]+ipRouter[1]+ipRouter[2] || ipValid[3] <= 1 || ipValid[3] >= 255){
				Notify.alert('IP fuera del rango', {status: 'danger'});
				return;
			}

			$scope.loading = "whirl double-up";
			$http.post('/api/admin/devices/saveDevice', {
				device : $scope.device,
				user : $rootScope.user
			}).then(function(res) {

				$scope.loading = "";
				var response = res['data'];
				if (response['success']) {
					Notify.alert('El dispositivo se guardó de forma correcta', {status: 'success'},)
					response.device.isNew = response.isNew;
					$scope.closeThisDialog(response.device)
				}
				if (response['success'] == false && response ['duplicateIp']==true) {
					Notify.alert('La IP que desea registrar ya existe', {status: 'danger'});
					return;
				}
			});
		};

		$scope.doPing = function(){
			$scope.loading = "whirl double-up";

			$http.post('/api/admin/devices/doPing', {
				ipAddress : $scope.device.ip,
				user : $rootScope.user
			}).then(function(res) {

				$scope.loading = "";
				var response = res['data'];
				if (response.success && response.pingResult) {
					Notify.alert('El dispositivo respondió de forma correcta.', {status: 'success'});
				}else{
					Notify.alert('El dispositivo NO responde.', {status: 'warning'});
				}
			});
		};

		$scope.showAddDevice = function(){
			$scope.newPath = {path: '', fileName: '', startLine: '', columns: '', separatorr: '',
				formatDate: '', formatTime: '', encoding: ''};
			$( "#addPath" ).toggle();
		};

		$scope.hideAddDevice = function(){
			$( "#addPath" ).hide();
		};

		$scope.addDevice = function(){
			if ($scope.newPath.path.length < 2) {
				Notify.alert('Ingrese un directorio válido..', {status: 'danger'});
				return;
			}else if ($scope.newPath.fileName.length < 2) {
				Notify.alert('Ingrese un nombre de archivo válido..', {status: 'danger'});
				return;
			}else if ($scope.newPath.startLine.length < 1) {
				Notify.alert('Seleccione un inicio de línea válido.', {status: 'danger'});
				return;
			}else if ($scope.newPath.columns.length < 1) {
				Notify.alert('Seleccione orden de fecha válido', {status: 'danger'});
				return;
			}else if ($scope.newPath.separatorr.length < 1) {
				Notify.alert('Seleccione un separador de datos válido.', {status: 'danger'});
				return;
			}else if ($scope.newPath.formatDate.length < 1) {
				Notify.alert('Seleccione un formato de fecha válido', {status: 'danger'});
				return;
			}else if ($scope.newPath.formatTime.length < 1) {
				Notify.alert('Seleccione un formato de hora válido.', {status: 'danger'});
				return;
			}else if ($scope.newPath.encoding.length < 1) {
				Notify.alert('Seleccione un encoding válido.', {status: 'danger'});
				return;
			}

			$scope.loading = "whirl double-up";
			$scope.newPath.id_customerDevice = $scope.device.id;

			$http.post('/api/admin/devices/savePath', {
				newPath : $scope.newPath,
				user : $rootScope.user
			}).then(function(res) {

				$scope.loading = "";
				let response = res['data'];
				if (response['success']) {
					Notify.alert('El archivo se agregó de forma correcta.', {status: 'success'});
					if($scope.newPath.id == undefined) {
						$scope.device.paths.push(response.newPath);
						$scope.ngDialogData.device.paths.push(response.newPath);
						$( "#addPath" ).hide();
					}else{
						for(let x = 0; x < $scope.ngDialogData.device.paths.length; x++){
							if($scope.ngDialogData.device.paths[x].id == $scope.newPath.id){
								$scope.ngDialogData.device.paths[x].path = $scope.newPath.path;
								$scope.ngDialogData.device.paths[x].fileName = $scope.newPath.fileName;
								$scope.ngDialogData.device.paths[x].label = $scope.newPath.label;
								$scope.ngDialogData.device.paths[x].startLine = $scope.newPath.startLine;
								$scope.ngDialogData.device.paths[x].separatorr = $scope.newPath.separatorr;
								$scope.ngDialogData.device.paths[x].formatDate = $scope.newPath.formatDate;
								$scope.ngDialogData.device.paths[x].formatTime = $scope.newPath.formatTime;
								$scope.ngDialogData.device.paths[x].encoding = $scope.newPath.encoding;
							}
						}
					}
				}
			});
		};

		$scope.editPath = function(element){
			$scope.newPath = element;

			$scope.newPath.columns += '';
			$scope.newPath.separatorr += '';
			$scope.newPath.startLine += '';


			$( "#addPath" ).show();
			$("#modalDiv").animate({
				scrollTop: $("#addFileDiv").offset().top
			}, 1000);
		};

		$scope.deletePath = function(id, index){

			$http.post('/api/admin/devices/deletePath', {
				user : $rootScope.user,
				id_path : id
			}).then(function(res) {

				$scope.loading = "";
				let response = res['data'];
				if (response['success']) {
					Notify.alert('El archivo se eliminó de forma correcta.', {status: 'success'});
					$scope.device.paths.splice(index, 1);
				}
			});

		};

	};

})();