<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<style type="text/css">
body {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 14px;
	color: #666;
	border: 1px solid #666;
	padding: 10px;
}

small {
	font-size: 13px;
}
table{
	width: 100%;
}
table{
	color: #000;
	font-size: 13px;
}
.row {
	width: 100%;
	padding-bottom: 15px;
	padding-top: 15px;
}

.text-center {
	text-align: center;
}

.muted-txt {
	color: #666
}

.pb10 {
	padding-bottom: 10px;
}

.pt10 {
	padding-top: 10px;
}

.pt20 {
	padding-top: 20px;
}

.col-lg-1, .col-lg-2, .col-lg-3, .col-lg-4, .col-lg-5, .col-lg-6,
	.col-lg-7, .col-lg-8, .col-lg-9, .col-lg-10, .col-lg-11, .col-lg-12 {
	float: left;
}

.col-lg-12 {
	width: 100%;
}

.col-lg-11 {
	width: 91.66666667%;
}

.col-lg-10 {
	width: 83.33333333%;
}

.col-lg-9 {
	width: 75%;
}

.col-lg-8 {
	width: 66.66666667%;
}

.col-lg-7 {
	width: 58.33333333%;
}

.col-lg-6 {
	width: 50%;
}

.col-lg-5 {
	width: 41.66666667%;
}

.col-lg-4 {
	width: 33.33333333%;
}

.col-lg-3 {
	width: 25%;
}

.col-lg-2 {
	width: 16.66666667%;
}

.col-lg-1 {
	width: 8.33333333%;
}

.bg-green {
	background-color: #37bc9b;
	color: #ffffff !important;
}

.bg-primary {
	background-color: #5d9cec;
	color: #ffffff !important;
}

.bg-danger {
	background-color: #f05050;
	color: #ffffff !important;
}

.p20 {
	padding: 20px;
}

.m10 {
	margin: 1px;
}
.p10{
	padding: 10px;
}
.rounded {
	border-radius: 10px;
}
.text-success {
    color: #37bc9b;
}
.text-primary {
    color: #5d9cec;
}
.text-danger {
    color: #f05050;
}
.text-gray{
	color: #666;
}
.backgroud-green{
	background: #BAE6CC;
}
.text16{
	font-size: 14px;
}
.text14{
	font-size: 14px;
}
.borderRadius{
	border-radius: 10px;
}
.text-left{
	text-align: left;
}
.text-right{
	text-align: right;
}
.bordered td, .bordered th{
	border: 1px solid #000;
	padding: 0px;
	margin: 0px;
	padding-left: 0px;
}
.bordered tr{
	padding: 0px;
	margin: 0px;
	padding-left: 0px;
}
.minHeight{
	height: 13px;
}
</style>
</head>
<body>
	<table>
		<tr>
			<td style="width: 110px;"><img src="app/img/logo_color.png" style="height: 100px;" /></td>
			<td class="text-center text16">
				SITMA Industrial SA de CV<br /><br />
				<span class="text-gray text14">
				Alambiques  N° 2844 Fraccionamiento Álamo Industrial
				<br />Tlaquepaque, Jalisco  C.P. 45609  
				<br />Teléfono: (33) 3343 1463 /  1465  Ext.102
				<br />ventas@sitma.com.mx   www.sitma.com.mx
				</span>
			</td>
			<td style="width: 120px;">
				<table>
					<tr>
						<td class="text-center backgroud-green borderRadius">COTIZACIÓN</td>
					</tr>
					<tr>
						<td class="text-center">{{$quotation['noPO']}}</td>
					</tr>
					<tr>
						<td class="text-center backgroud-green borderRadius">FECHA</td>
					</tr>
					<tr>
						<td class="text-center">{{$quotation['quotationDate']}}</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
	<div class="text-center row">
		Cotización SITMA <br> 
	</div>
	<table>
		<tr>
			<th class="text-left">Cliente:</th>
			<td colspan="3">{{$quotation['customer']['name']}}</td>
		</tr>
		<tr>
			<th class="text-left">Dirección:</th>
			<td colspan="3">{{$quotation['customer']['address']}}</td>
		</tr>
		<tr>
			<th class="text-left">Teléfono:</th>
			<td>{{$quotation['customer']['phone']}}</td>
			<th class="text-left">Email:</th>
			<td>{{$quotation['customer']['email']}}</td>
		</tr>
		<tr>
			<th class="text-left">RFC:</th>
			<td>{{$quotation['customer']['taxdata']['rfc']}}</td>
			<th class="text-left">Ejecutivo:</th>
			<td>{{$quotation['employee']['name']}}</td>
		</tr>
	</table>
	<div class="row text16">
			De conformidad con su amable solicitud de cotización, sirva recibir nuestra oferta técnica y económica, en la que esperamos vernos favorecidos:
	</div>
	
	<table class="bordered" cellpadding="0">
		<thead>
			<tr>
				<th class="text-left">Cantidad</th>
				<th class="text-left" style="width: 400px;">Producto</th>
				<th class="text-center">P. Unitario</th>
				<th class="text-center">Total</th>
			</tr>
		</thead>
		<tbody>
            @foreach($quotation['details'] as $detail)
            	<tr>
            		<td class="text-left minHeight">{{$detail['qty']}}</td>
                  	<td class="text-left">{{$detail['name'] }}</td>
                  	<td class="text-center">{{$detail['finalPrice']}}</td>
                  	<td class="text-center">{{$detail['totalPrice']}}</td>
            	</tr>
            @endforeach
		</tbody>
		<tfoot>
			<tr>
				<td colspan="2" rowspan="5" class="m10"><div style="padding: 15px;">{{$quotation['externalComment']}}</div></td>
				<th class="text-right">Sub-Total:</th>
				<td class="text-center">{{number_format($quotation['subTotal'],2)}}</td>
			</tr>
			<tr>
				<th class="text-right">Descuento (%):</th>
				<td class="text-center">{{number_format($quotation['discount'], 2)}}</td>
			</tr>
			<tr>
				<th class="text-right">Nota de crédito (-):</th>
				<td class="text-center">{{number_format($quotation['creditNote'], 2)}}</td>
			</tr>
			<tr>
				<th class="text-right">IVA:</th>
				<td class="text-center">{{number_format($quotation['iva'], 2)}}</td>
			</tr>
			<tr>
				<th class="text-right">Total:</th>
				<td class="text-center">{{number_format($quotation['total'], 2)}}</td>
			</tr>
		</tfoot>
	</table>
	
	<div class="text-left row text14">
		<p><strong>TÉRMINOS Y CONDICIONES:</strong></p>
		<p>
			- Los precios son LAB, instalaciones de SITMA, con tarifas preferenciales a toda la República Mexicana<br />							
			 - La forma de pago es,	{{$quotation['paymentMethod']}}<br />
			 - Tiempo de entrega,	{{$quotation['deliveryTime']}}<br />
			 - Para cualquiera de nuestros productos se emitirá un certificado de calidad,<br /> 	
			 - Los productos estarán garantizados por 3 años de operación,<br />
			 - Cumplimos con las mas exigentes Normas Internacionales aplicables a este genero de productos, 								
			 							
			 							
			 
			
		</p> 
	</div>
	
</body>
</html>
