<?php

use App\Http\Controllers\AlertController;
use App\Http\Controllers\BillsController;
use App\Http\Controllers\CustomersController;
use App\Http\Controllers\DevicesController;
use App\Http\Controllers\EmployeesController;
use App\Http\Controllers\GeneralController;
use App\Http\Controllers\PLCSController;
use App\Http\Controllers\ProductsController;
use App\Http\Controllers\RegistersController;
use App\Http\Controllers\RoutersController;
use App\Http\Controllers\SettingsController;
use App\Http\Controllers\TasksController;
use App\Http\Controllers\UsersController;
use App\Http\Controllers\WorksheetsController;
use App\Http\Controllers\WSController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "api" middleware group. Make something great!
|
*/

Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});

Route::post("admin/facturacion/getProducts", [FacturacionController::class, 'getProducts']);



Route::post('admin/login', [EmployeesController::class, "login"]);

Route::post("admin/employees/getEmployees", [EmployeesController::class, "getEmployees"]);
Route::post("admin/employees/getEmployee", [EmployeesController::class, "getEmployee"]);
Route::post('admin/employees/saveEmployee', [EmployeesController::class, "saveEmployee"]);
Route::post('admin/employees/deleteEmployee', [EmployeesController::class, "deleteEmployee"]);
Route::get('admin/employees/test', [EmployeesController::class, "test"]);
Route::get('admin/employees/processEvents', [EmployeesController::class, "processEvents"]);

Route::post("admin/customers/getCustomers", [CustomersController::class, "getCustomers"]);
Route::post("admin/customers/getCustomer", [CustomersController::class, "getCustomer"]);
Route::post('admin/customers/saveCustomer', [CustomersController::class, "saveCustomer"]);
Route::post('admin/customers/deleteCustomer', [CustomersController::class, "deleteCustomer"]);
Route::post('admin/customers/addDevice', [CustomersController::class, "addDevice"]);
Route::post('admin/customers/getDeviceDetails', [CustomersController::class, "getDeviceDetails"]);
Route::post('admin/customers/disableEnableDevice', [CustomersController::class, "disableEnableDevice"]);
Route::post('admin/customers/addVariable', [CustomersController::class, "addVariable"]);
Route::post('admin/customers/deleteVariable', [CustomersController::class, "deleteVariable"]);
Route::post('admin/customers/getLoginHistoric', [CustomersController::class, "getLoginHistoric"]);
Route::post('admin/customers/sendEmailSupport', [CustomersController::class, "sendEmailSupport"]);
Route::post('admin/customers/activateNotifications', [CustomersController::class, "activateNotifications"]);
Route::post('admin/customers/uploadImageCustomer', [CustomersController::class, "uploadImageCustomer"]);
Route::post('admin/customers/uploadImageHome', [CustomersController::class, "uploadImageHome"]);
Route::post('admin/customers/uploadFileVPNCustomer', [CustomersController::class, "uploadFileVPNCustomer"]);
Route::post('admin/customers/getDownloadVPNLog', [CustomersController::class, "getDownloadVPNLog"]);
Route::get('admin/customers/getFile', [CustomersController::class, "getFile"]);
Route::post('admin/customers/updateLastLoginActivity', [EmployeesController::class, "updateLastLoginActivity"]);
Route::post('admin/customers/deleteFile', [CustomersController::class, "deleteFile"]);
Route::post('admin/customers/removeRouter', [CustomersController::class, "removeRouter"]);

Route::post("admin/products/getProducts", [ProductsController::class, "getProducts"]);
Route::post("admin/products/getProduct", [ProductsController::class, "getProduct"]);
Route::post('admin/products/saveProduct', [ProductsController::class, "saveProduct"]);
Route::post('admin/products/deleteProduct', [ProductsController::class, "deleteProduct"]);

Route::post("admin/general/getConfigurationData", [GeneralController::class, "getConfigurationData"]);
Route::post("admin/general/saveConfigurationData", [GeneralController::class, "saveConfigurationData"]);

Route::post("admin/bills/getBills", [BillsController::class, "getBills"]);
Route::post("admin/bills/getBillDetails", [BillsController::class, "getBillDetails"]);
Route::post("admin/bills/sendEmail", [BillsController::class, "sendEmail"]);

Route::post("admin/WS/receiveFiles", [WSController::class, "receiveFiles"]);

Route::post("admin/registers/getRegisters", [RegistersController::class, "getRegisters"]);
Route::post("admin/registers/getRegisterDetails", [RegistersController::class, "getRegisterDetails"]);

Route::post("admin/tasks/getTasks", [TasksController::class, "getTasks"]);
Route::post("admin/tasks/saveTask", [TasksController::class, "saveTask"]);
Route::post("admin/tasks/deleteTask", [TasksController::class, "deleteTask"]);

Route::post("uploadFileXLS", [WSController::class, "uploadFiles"]);

Route::post("admin/devices/getDevices", [DevicesController::class, "getDevices"]);
Route::post("admin/devices/getDevice", [DevicesController::class, "getDevice"]);
Route::post("admin/devices/asignDevice", [DevicesController::class, "asignDevice"]);
Route::post("admin/devices/saveData", [DevicesController::class, "saveData"]);
Route::any("admin/devices/isCustomerDeviceOnline", [DevicesController::class, "isCustomerDeviceOnline"]);
Route::post("admin/devices/setCustomerDeviceOnline", [DevicesController::class, "setCustomerDeviceOnline"]);
Route::post("admin/devices/getReportRegisters", [DevicesController::class, "getReportRegisters"]);
Route::post("admin/devices/getAlerts", [DevicesController::class, "getAlerts"]);
Route::post("admin/devices/saveDevice", [DevicesController::class, "saveDevice"]);
Route::post("admin/devices/saveVarData", [DevicesController::class, "saveVarData"]);
Route::post("admin/devices/getActiveHMI", [DevicesController::class, "getActiveHMI"]);
Route::post("admin/devices/getActiveToPing", [DevicesController::class, "getActiveToPing"]);
Route::post("admin/devices/reportPingResults", [DevicesController::class, "reportPingResults"]);
Route::post("admin/devices/requestDownloadFile", [DevicesController::class, "requestDownloadFile"]);
Route::post("admin/devices/doPing", [DevicesController::class, "doPing"]);
Route::post("admin/devices/doPingServer", [DevicesController::class, "doPingServer"]);
Route::get("admin/devices/test", [DevicesController::class, "test"]);
Route::post("admin/devices/savePath", [DevicesController::class, "savePath"]);
Route::post("admin/devices/deletePath", [DevicesController::class, "deletePath"]);
Route::post("admin/devices/getFileList", [DevicesController::class, "getFileList"]);
Route::post("admin/devices/requestDatesFile", [DevicesController::class, "requestDatesFile"]);
Route::post("admin/devices/verifyFile", [DevicesController::class, "verifyFile"]);
Route::post("admin/devices/saveFileConfig", [DevicesController::class, "saveFileConfig"]);
Route::post("admin/devices/addAlarm", [DevicesController::class, "addAlarm"]);
Route::get("admin/devices/downloadFile", [DevicesController::class, "downloadFile"]);
Route::post("admin/devices/saveActivateBackupConfig", [DevicesController::class, "saveActivateBackupConfig"]);
Route::post("admin/devices/saveBackupsConfig", [DevicesController::class, "saveBackupsConfig"]);

Route::post("admin/routers/saveRouter", [RoutersController::class, "saveRouter"]);
Route::post("admin/routers/updateRouter", [RoutersController::class, "updateRouter"]);
Route::post("admin/routers/getRoutersByCustomer", [RoutersController::class, "getRoutersByCustomer"]);
Route::post("admin/routers/getRouteSito", [RoutersController::class, "getRouteSito"]);

Route::post("admin/users/saveUser", [UsersController::class, "saveUser"]);
Route::post("admin/users/getUsers", [UsersController::class, "getUsers"]);
Route::post("admin/users/getUser", [UsersController::class, "getUser"]);
Route::post("admin/users/deleteUser", [UsersController::class, "deleteUser"]);

Route::get("menu/getmenu", [EmployeesController::class, "getMenu"]);

Route::post("admin/settings/getSettings", [SettingsController::class, "getSettings"]);
Route::post("admin/settings/saveSettings", [SettingsController::class, "saveSettings"]);
Route::post("admin/settings/saveDoc", [SettingsController::class, "saveDoc"]);
Route::post("admin/settings/deleteDoc", [SettingsController::class, "deleteDoc"]);
Route::post("admin/settings/getDocList", [SettingsController::class, "getDocList"]);
Route::get("admin/settings/downloadFile", [SettingsController::class, "downloadFile"]);

Route::post("admin/plcs/getPLCs", [PLCSController::class, "getPLCs"]);
Route::post("admin/plcs/getPLC", [PLCSController::class, "getPLC"]);
Route::post("admin/plcs/savePLC", [PLCSController::class, "savePLC"]);
Route::post("admin/plcs/saveRegister", [PLCSController::class, "saveRegister"]);
Route::post("admin/plcs/getLiveData", [PLCSController::class, "getLiveData"]);
Route::post("admin/plcs/setRegisterValue", [PLCSController::class, "setRegisterValue"]);
Route::post("admin/plcs/deleteRegister", [PLCSController::class, "deleteRegister"]);

Route::post("admin/worksheets/save", [WorksheetsController::class, "save"]);
Route::post("admin/worksheets/get", [WorksheetsController::class, "get"]);
Route::post("admin/worksheets/gets", [WorksheetsController::class, "gets"]);
Route::post("admin/worksheets/delete", [WorksheetsController::class, "delete"]);
Route::post("admin/worksheets/uploadImage", [WorksheetsController::class, "uploadImage"]);
Route::post("admin/worksheets/getRegisters", [WorksheetsController::class, "getRegisters"]);
Route::post("admin/worksheets/deleteWorkSheet", [WorksheetsController::class, "delete"]);
Route::post("admin/worksheets/getLiveData", [WorksheetsController::class, "getLiveData"]);


Route::post("admin/alarms/getAlerts", [AlertController::class, "getAlerts"]);
Route::post("admin/alarms/getCustomers", [AlertController::class, "getCustomers"]);
Route::post("admin/alarms/getDevices", [AlertController::class, "getDevices"]);
